

class SurvivalGame extends TeamGamePlus
	config(Survival2);

#exec TEXTURE IMPORT NAME=goldplayer FILE=textures\gold.PCX GROUP=Skins
//Import HUD elements:
#exec TEXTURE IMPORT NAME=RPGelement FILE=Textures\RPGelement.bmp
#exec TEXTURE IMPORT NAME=RPGstatusbar FILE=Textures\RPGstatusbar.bmp
//Import Stat tree elemets:
#exec TEXTURE IMPORT NAME=Icon_AmmoRegain FILE=Textures\Icon_AmmoRegain.bmp
#exec TEXTURE IMPORT NAME=Icon_ArmorRegain FILE=Textures\Icon_ArmorRegain.bmp
#exec TEXTURE IMPORT NAME=Icon_DamageAmp FILE=Textures\Icon_DamageAmp.bmp
#exec TEXTURE IMPORT NAME=Icon_HealthRegain FILE=Textures\Icon_HealthRegain.bmp
#exec TEXTURE IMPORT NAME=Icon_ReduceDamage FILE=Textures\Icon_ReduceDamage.bmp
#exec TEXTURE IMPORT NAME=Icon_SpeedAmp FILE=Textures\Icon_SpeedAmp.bmp
#exec TEXTURE IMPORT NAME=StatTreeElement FILE=Textures\StatTreeElement.bmp

var config string RPGstatusXpos,RPGtreeXpos;
Var config float RPGstatusYpos, Progress;

var config bool bShowMonsterHealth;    	//Dane's add

// ========================================
// Const, Definition
var String MSG_NOPLAYER;		// value = "No Player"
var String MSG_INVASION;		// value = "Invasion Allowed"
var String MSG_DESTROYED;		// value = "No ControlPoint"
var String MSG_TIMEOUT;			// value = "Time Out"
var String MSG_WONGAME;			// value = "Won the Game"

var int START_ROUND;			// value = 1
var int FINAL_ROUND;			// value = 16

// ========================================
// Game Variables.
var String TimeOutMessage;
var String NoPlayerEndedMessage;
var String InvasionAllowedMessage;
var String ControlDestroyedMessage;

var bool bInitGame;
var bool bFirstChecked;
var bool bWaveStarting;
var bool bMutateInitFor;

var bool bWaveProgress;
var float NextSpawnTime;

var int WaveStartCountDown;
var int WaveRound;
var int DomCountDown;

var class<Weapon> TrooperWeapons[17];
var class<ScriptedPawn> MonsterClass[16];
var class<ScriptedPawn> WaveMonsterClass[16];
var int WaveNumClasses;

var int NumSpawnPoint;
var float WaveEndTime;

struct WaveInfo
{
	var int WaveMask;
	var int SpawnMonsterTotal;
	var float WaveDuration;
	var float WaveDifficulty;
};

// ========================================
// Game Config Variables.
var config int Lives;
var config int InitialWave;
var config int FinalWave;

var config WaveInfo Waves[16];

// ========================================
// PreCache Monster Meshes.
function PreCacheReferences() 
{
	//never called - here to force precaching of meshes
	Spawn(class'UnrealShare.Fly');
	Spawn(class'UnrealShare.Manta');
	Spawn(class'UnrealShare.CaveManta');
	Spawn(class'UnrealI.GiantManta');
	Spawn(class'UnrealI.Pupae');
	Spawn(class'UnrealI.Gasbag');
	Spawn(class'UnrealI.GiantGasbag');
	Spawn(class'UnrealShare.Slith');
	Spawn(class'UnrealI.Krall');
	Spawn(class'UnrealI.KrallElite');
	Spawn(class'UnrealI.Mercenary');
	Spawn(class'UnrealI.MercenaryElite');
	Spawn(class'UnrealShare.LesserBrute');
	Spawn(class'UnrealShare.Brute');
	Spawn(class'UnrealI.Behemoth');
	Spawn(class'UnrealShare.SkaarjWarrior');
	Spawn(class'UnrealShare.SkaarjScout');
	Spawn(class'UnrealI.IceSkaarj');
	Spawn(class'UnrealI.SkaarjAssassin');
	Spawn(class'UnrealI.SkaarjLord');
	Spawn(class'UnrealI.SkaarjBerserker');
	Spawn(class'UnrealI.SkaarjTrooper');
	Spawn(class'UnrealI.SkaarjInfantry');
	Spawn(class'UnrealI.SkaarjGunner');
	Spawn(class'UnrealI.SkaarjOfficer');
	Spawn(class'UnrealI.SkaarjSniper');
	Spawn(class'UnrealShare.DevilFish');
	Spawn(class'UnrealI.Titan');
	Spawn(class'UnrealI.StoneTitan');
	Spawn(class'UnrealI.WarLord');
	Spawn(class'UnrealI.Queen');
//added monsters
	Spawn(class'Survival2.LavaSlith');
	Spawn(class'Survival2.LavaTitan');
	Spawn(class'Survival2.WaterTitan');
	Spawn(class'Spinner.Spinner');
	Spawn(class'SVcyborg');
	Spawn(class'SVEant');
	Spawn(class'SVQueen');
	Spawn(class'SVmaiden');
	Spawn(class'SVPredator');
	Spawn(class'SVshadow');
	Spawn(class'SVManta');
	Spawn(class'SciKrall');
	Spawn(class'SVQueen2');
	
}

// ========================================
// GameInit.
function PostBeginPlay() 
{
	
	local ScriptedPawn S;
	local SV_ReplicationInfo ACGRI;
	local NavigationPoint NP;
	

	ACGRI = SV_ReplicationInfo(GameReplicationInfo);

	foreach AllActors(class'ScriptedPawn', S) 
        {
		if (!S.IsA('Nali') && !S.IsA('Cow'))
			S.AttitudeToPlayer = ATTITUDE_Ignore;
	}
	
	if (InitialWave < 1)
		InitialWave = 1;
	
	if (FinalWave > 16)
		FinalWave = 16;
	
	if (InitialWave > 16) 
        {
		InitialWave = FinalWave;
	} 
        else if (InitialWave > FinalWave) 
        {
		FinalWave = InitialWave;
	}

	ACGRI.Xpos = RPGstatusXpos;
	ACGRI.Ypos = RPGstatusYpos;
	ACGRI.Xpos2 = RPGtreeXpos;
	ACGRI.Progress = Progress; //fictive

	ACGRI.bShowMonsterHealth = bShowMonsterHealth;
	ACGRI.CurrentWave = InitialWave - 1;
	ACGRI.MonsterTotal = 0;
	
	bInitGame = false;
	bFirstChecked = false;
	bWaveStarting = false;
	bWaveProgress = false;
	bMutateInitFor = false;

	NumSpawnPoint = 0;
	for (NP = Level.NavigationPointList; NP != None; NP = NP.NextNavigationPoint)
		if (NP.IsA('PathNode'))
			NumSpawnPoint++;

	//Super.PostBeginPlay();

	

	Super(TeamGamePlus).PostBeginPlay();
}

// ========================================
// GameInit.
event InitGame(String Options, out String Error) 
{
	
	local String InOpt;
	
	Super(TournamentGameInfo).InitGame(Options, Error);
	
	RemainingTime = 60 * TimeLimit;
	SetGameSpeed(GameSpeed);
	FragLimit = GetIntOption(Options, "FragLimit", FragLimit);
	TimeLimit = GetIntOption(Options, "TimeLimit", TimeLimit);
	MaxCommanders = GetIntOption(Options, "MaxCommanders", MaxCommanders);
	InOpt = ParseOption(Options, "CoopWeaponMode");
	if (InOpt != "")
		bCoopWeaponMode = bool(InOpt);
	
	IDNum = -1;
	IDNum = GetIntOption(Options, "Tournament", IDNum);
	if (IDNum > 0) 
        {
		bRatedGame = true;
		TimeLimit = 0;
		RemainingTime = 0;
	}
	if (Level.NetMode == NM_StandAlone) 
        {
		bRequireReady = true;
		CheckReady();
	}
	if (Level.NetMode == NM_StandAlone) 
        {
		bRequireReady = true;
		CountDown = 1;
	}
	if (!bRequireReady && (Level.NetMode != NM_Standalone)) 
        {
		bRequireReady = true;
		bNetReady = true;
	}
	bJumpMatch = false;
}

// ========================================
// Startup Message.
function PlayStartUpMessage(PlayerPawn NewPlayer) 
{
	local int i;
	local Color Green, DarkGreen;
	
	NewPlayer.ClearProgressMessages();
	
	Green.G = 255;
	Green.B = 128;
	DarkGreen.G = 200;
	DarkGreen.B = 64;
	
	NewPlayer.SetProgressColor(Green, i);
	
	NewPlayer.SetProgressMessage(GameName, i++);
	if (bRequireReady && (Level.NetMode != NM_Standalone)) 
        {
		NewPlayer.SetProgressColor(Green, i);
		NewPlayer.SetProgressMessage(TourneyMessage, i++);
	} 
        else 
        {
		NewPlayer.SetProgressColor(Green, i);
		NewPlayer.SetProgressMessage(StartUpMessage, i++);
	}
	
	if (Level.NetMode == NM_Standalone)
		NewPlayer.SetProgressMessage(SingleWaitingMessage, i++);
}

// ========================================
// Game Ended, Set Cams Player.
function bool SetEndCams(String Reason) 
{

	local bool bVal;
	local Pawn P, Best;
	local PlayerPawn PL;
	local string SkipPlayer;
	local Loser  WS;


	bVal = true;
	
	// find score getter
	for (P = Level.PawnList; P != None; P = P.NextPawn) 
        	{
		if (P.bIsPlayer && ((Best == None) || (P.PlayerReplicationInfo.Score > Best.PlayerReplicationInfo.Score))) 
                        {
			Best = P;
			SkipPlayer = P.PlayerReplicationInfo.PlayerName;
			}
		}
	
	// No Player
	if (Reason == MSG_NOPLAYER) 
        {
		bVal = false;
		GameEndedMessage = NoPlayerEndedMessage;
	}
	
	// Invasion Allowed...
	if (Reason == MSG_INVASION)
        {
		bVal = false;
		GameEndedMessage = InvasionAllowedMessage;
	}
	
	if (Reason == MSG_DESTROYED) 
        {
		bVal = false;
		GameEndedMessage = ControlDestroyedMessage;
	}
	
	// Timeout or Final Wave Clear
	if ((RemainingTime == 0) && (TimeLimit >= 1))
		GameReplicationInfo.GameEndedComments = TimeOutMessage;
	else
		GameReplicationInfo.GameEndedComments = GameEndedMessage;
	
	EndTime = Level.TimeSeconds + 3.0;
	for (P = Level.PawnList; P != None; P = P.NextPawn) 
        {
		PL = PlayerPawn(P);
		if (PL != None) 
                {
			if (!bTutorialGame)
				PlayWinMessage(PL, bVal);
			PL.bBehindView = true;
			if ( PL.PlayerReplicationInfo.PlayerName != SkipPlayer )
				{
				     PL.PlayerReplicationInfo.Deaths = 0;
                                     PL.ViewTarget = Best;
				     PL.SetDisplayProperties(ERenderStyle.STY_Modulated,Texture'UnrealShare.JGCow1',true,true);;
                                     spawn(class'Loser',PL,,PL.Location+vect(0,0,60));
                                     PL.GotoState('FeigningDeath');
                                     //spawn(class'Pylon',PL,,PL.Location+ 72 * Vector(Rotation) + vect(0,0,1) * 15);
                                     //Spawn( class'Pylon',,,Location);
                                 }
		  	          else
       			          {
				     PL.ViewTarget = None;
				     spawn(class'Winner',PL,,PL.Location+vect(0,0,60));
				     PL.SetDisplayProperties(ERenderStyle.STY_Translucent,Texture'goldplayer',true,true);;
				     //PL.SetDisplayProperties(ERenderStyle.STY_Modulated,Texture'UnrealShare.JGCow1',true,true);;
				     //PL.SetDisplayProperties(ERenderStyle.STY_Translucent,FireTexture'UnrealShare.Belt_fx.ShieldBelt.N_Shield',true,true);;
			          }
			PL.ClientGameEnded();
		}
		P.GotoState('GameEnded');
	}
	CalcEndStats();
	return true;
}
// ========================================
// Give Default Inventory
function AddDefaultInventory(Pawn PlayerPawn) 
{
	
	local Weapon newWeapon;
	local class<Weapon> WeapClass;
	local Bot B;
	
	if (PlayerPawn.IsA('Spectator') || (bRequireReady && (CountDown > 0)))
		return;
	
	// Spawn Automag
	GiveWeapon(PlayerPawn, "Survival2.SVEnforcer");
	
	// SUPER ===============================================
		PlayerPawn.JumpZ = PlayerPawn.Default.JumpZ * PlayerJumpZScaling();
		
		if( PlayerPawn.IsA('Spectator') )
			return;
		
		// Spawn default weapon.
		WeapClass = BaseMutator.MutatedDefaultWeapon();
		if( (WeapClass!=None) && (PlayerPawn.FindInventoryType(WeapClass)==None) )
		{
			newWeapon = Spawn(WeapClass,,,PlayerPawn.Location);
			if( newWeapon != None )
			{
				newWeapon.Instigator = PlayerPawn;
				newWeapon.BecomeItem();
				PlayerPawn.AddInventory(newWeapon);
				newWeapon.BringUp();
				newWeapon.GiveAmmo(PlayerPawn);
				newWeapon.SetSwitchPriority(PlayerPawn);
				newWeapon.WeaponSet(PlayerPawn);
			}
		}
		BaseMutator.ModifyPlayer(PlayerPawn);
	// END SUPER ===========================================
	
	B = Bot(PlayerPawn);
	if ( B != None )
		B.bHasImpactHammer = (B.FindInventoryType(class'ImpactHammer') != None);
	
	ResetWeapon(PlayerPawn);
}

function bool CanSpectate(Pawn Viewer, Actor ViewTarget)
{
	
	if (ViewTarget.bIsPawn && (Pawn(ViewTarget).PlayerReplicationInfo != None)
		&& Pawn(ViewTarget).PlayerReplicationInfo.bIsSpectator)
		return false;
	
	if (ViewTarget.bIsPawn && Pawn(ViewTarget).bIsPlayer
		&& !Pawn(ViewTarget).PlayerReplicationInfo.bIsSpectator)
		return true;
	
	return false;
}

// ========================================
// Player join the Game
function PlayerPawn Login 
(
	String Portal,
	String Options,
	out String Error,
	class<PlayerPawn> SpawnClass
) 
{
	local PlayerPawn NewPlayer;
	local NavigationPoint StartNP;
	
	NewPlayer = Super.Login(Portal, Options, Error, SpawnClass);
	
	if (NewPlayer == None)
		return None;
	
	if (bSpawnInTeamArea) 
        {
		StartNP = FindPlayerStart(NewPlayer, 0, Portal);
		if (StartNP != None) 
                {
			NewPlayer.SetLocation(StartNP.Location);
			NewPlayer.SetRotation(StartNP.Rotation);
			NewPlayer.ViewRotation = StartNP.Rotation;
			NewPlayer.ClientSetRotation(NewPlayer.Rotation);
			StartNP.PlayTeleportEffect(NewPlayer, true);
		}
	}
	PlayerTeamNum = NewPlayer.PlayerReplicationInfo.Team;
	
	if ((NewPlayer != None) && (!NewPlayer.IsA('Spectator')))
		NewPlayer.PlayerReplicationInfo.Deaths = Lives;
	
	CheckPlayerTotal();
	return NewPlayer;
}

// ========================================
// Restarting PlayerPawn
function bool RestartPlayer(Pawn aPlayer) 
{
	
	local NavigationPoint StartNP;
	local bool bFoundStart;
	local Pawn P;
	
	
	if(bRestartLevel && Level.NetMode != NM_DedicatedServer && Level.NetMode != NM_ListenServer)
		return true;
	
	if (aPlayer.PlayerReplicationInfo.Deaths < 1) 
        {
		for (P = Level.PawnList; P != None; P = P.NextPawn) 
                {
			if (P.bIsPlayer && (P.PlayerReplicationInfo.Deaths >= 1))
				P.PlayerReplicationInfo.Deaths += 0.00001;
		}
	}

	StartNP = FindPlayerStart(None, 255);
	if(StartNP == None)
		return false;
	
	bFoundStart = aPlayer.SetLocation(StartNP.Location);
	
	if (bFoundStart) 
        {
		StartNP.PlayTeleportEffect(aPlayer, true);
		aPlayer.SetRotation(StartNP.Rotation);
		aPlayer.ViewRotation = aPlayer.Rotation;
		aPlayer.Acceleration = vect(0,0,0);
		aPlayer.Velocity = vect(0,0,0);
		aPlayer.Health = 500;
		aPlayer.ClientSetRotation(StartNP.Rotation);
		aPlayer.bHidden = false;
		aPlayer.SoundDampening = aPlayer.Default.SoundDampening;
		if (aPlayer.PlayerReplicationInfo.Deaths < 1) 
                {
			aPlayer.bHidden = true;
			//aPlayer.PlayerRestartState = 'PlayerSpectating';
			aPlayer.PlayerRestartState = 'CheatFlying';
			aPlayer.ReducedDamageType = 'All';
			// test spectator mode - try overruling the SV spectator and just use default and set player to be waiting to join at next wave.
			aPlayer.PlayerReplicationInfo.bIsSpectator = true;
			aPlayer.PlayerReplicationInfo.bWaitingPlayer = true;
		} 
                else 
                {
			aPlayer.SetCollision(true, true, true);
			AddDefaultInventory(aPlayer);
			aPlayer.ReducedDamageType = '';
			aPlayer.PlayerRestartState = 'PlayerWalking';
			aPlayer.PlayerReplicationInfo.bIsSpectator = false;
			aPlayer.PlayerReplicationInfo.bWaitingPlayer = false;	
		}
	}
	
	

	CheckPlayerTotal();
	return bFoundStart;
}

function NotifySpree(Pawn Other, int num) 
{
	local Pawn P;

	if ( num == 15 )
		num = 0;
	else if ( num == 40 )
		num = 1;
	else if ( num == 75 )
		num = 2;
	else if ( num == 120 )
		num = 3;
	else if ( num == 175 )
		num = 4;
	else if ( num == 240 )
		num = 5;
	else
		return;
	
	for (P = Level.PawnList; P != None; P = P.NextPawn)
		if (P.IsA('TournamentPlayer'))
			P.ReceiveLocalizedMessage(class'SV_SpreeMessage', Num, Other.PlayerReplicationInfo );
}

function EndSpree(Pawn Killer, Pawn Other) 
{
	
	local Pawn P;
	
	if (!Other.bIsPlayer)
		return;
	for (P = Level.PawnList; P != None; P = P.NextPawn)
		if (P.IsA('TournamentPlayer'))
			if (Other.bIsPlayer)
				P.ReceiveLocalizedMessage(class'SV_SpreeMessage', Other.Spree, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo);
}

// ========================================
// Player or Monster Killing Procedure.
function Killed(Pawn Killer, Pawn Other, Name DamageType)
{
	
	local Pawn P;
	local bool bAutoTaunt;
	local int NextTaunt, i;
if (Killer != None)     //added check for access nones showing on server logs
    
   {
	if ((Killer != Other) && (Killer != None) && (DamageType == 'Decapitated'))
        {
	//	if (Level.Game.LocalLog != None)
	//		Level.Game.LocalLog.LogSpecialEvent("headshot", Killer.PlayerReplicationInfo.PlayerID, Other.PlayerReplicationInfo.PlayerID);
	//	if (Level.Game.WorldLog != None)
	//		Level.Game.WorldLog.LogSpecialEvent("headshot", Killer.PlayerReplicationInfo.PlayerID, Other.PlayerReplicationInfo.PlayerID);
		switch(Rand(5))
                {
			case 0 :
			        Killer.ReceiveLocalizedMessage(class'SV_HeadShotMessage5');
				break;
			case 1 :
				Killer.ReceiveLocalizedMessage(class'SV_HeadShotMessage4');
				break;
			case 2 :
				Killer.ReceiveLocalizedMessage(class'SV_HeadShotMessage3');
				break;
			case 3 :
				Killer.ReceiveLocalizedMessage(class'SV_HeadShotMessage2');
				break;
			default :
				Killer.ReceiveLocalizedMessage(class'SV_HeadShotMessage');
				break;
		}
	}
	
	Super(GameInfo).Killed(Killer, Other, DamageType);
	
	if (Other.Spree > 9)
		EndSpree(Killer, Other); 
	Other.Spree = 0;
	
	if (!bFirstBlood)
		if (Killer.bIsPlayer && (Killer != Other)) 
                {
			bFirstBlood = True;
			BroadcastLocalizedMessage(class'SV_FirstBloodMessage', WaveRound, Killer.PlayerReplicationInfo);
			if ( Level.Game.NumPlayers !=1 )
				{
                        	Killer.PlayerReplicationInfo.Deaths +=1;
				}
		}
	
	// Suicide
	if ((Killer != None && Other != None) && Killer == Other)
		Other.PlayerReplicationInfo.Score -= 4;
	
	// Monster
	if ((Killer != None && Other != None)
		&& Killer.IsA('ScriptedPawn') && Other.bIsPlayer) 
                {
		
		Other.PlayerReplicationInfo.Score -= 5;
	}
	
	if (Killer != None && Other != None && Killer != Other
		&& Killer.bIsPlayer && !Killer.IsA('Bot') && Other.IsA('ScriptedPawn')) 
                {
		Killer.Spree++;
		if ( Killer.Spree > 9 )
			NotifySpree(Killer, Killer.Spree);
		if ((TournamentPlayer(Killer).Level.TimeSeconds - TournamentPlayer(Killer).LastKillTime) < 3) 
                {
			TournamentPlayer(Killer).MultiLevel++;
			if(TournamentPlayer(Killer).MultiLevel >= 24)
				TournamentPlayer(Killer).MultiLevel = 23;
			TournamentPlayer(Killer).ReceiveLocalizedMessage(class'SV_MultiKillMessage', TournamentPlayer(Killer).MultiLevel);
			BroadCastMultiKill(Killer, TournamentPlayer(Killer).MultiLevel);
		} 
                else
			TournamentPlayer(Killer).MultiLevel = 0;
		
		TournamentPlayer(Killer).LastKillTime = TournamentPlayer(Killer).Level.TimeSeconds;
	}
	
	if ((Killer != None && Other != None) && Killer != Other
		&& (Killer.bIsPlayer || Killer.IsA('Bot')) && (Other.bIsPlayer || Other.IsA('Bot'))) 
                {
		
		Killer.ReceiveLocalizedMessage(class'SV_TeamKillMessage');
		Killer.PlayerReplicationInfo.Score -= 51;
		Other.PlayerReplicationInfo.Score += 1;
		for (P = Level.PawnList; P != None; P = P.NextPawn)
			if (P.IsA('TournamentPlayer'))
				if (P != Killer && P != Other)
					P.ReceiveLocalizedMessage(class'SV_TeamKillAnnounceMessage', , Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo);
	}
	
	// Auto Taunt - Ripping DeathMatchPlus
	bAutoTaunt = ((TournamentPlayer(Killer) != None) && TournamentPlayer(Killer).bAutoTaunt);
	if ( ((Bot(Killer) != None) || bAutoTaunt)
		&& (Killer != Other) && (DamageType != 'gibbed') && (Killer.Health > 0)
		&& (Level.TimeSeconds - LastTauntTime > 3) )
	{
		LastTauntTime = Level.TimeSeconds;
		NextTaunt = Rand(class<ChallengeVoicePack>(Killer.PlayerReplicationInfo.VoiceType).Default.NumTaunts);
		for ( i=0; i<4; i++ )
		{
			if ( NextTaunt == LastTaunt[i] )
				NextTaunt = Rand(class<ChallengeVoicePack>(Killer.PlayerReplicationInfo.VoiceType).Default.NumTaunts);
			if ( i > 0 )
				LastTaunt[i-1] = LastTaunt[i];
		}	
		LastTaunt[3] = NextTaunt;
 		killer.SendGlobalMessage(None, 'AUTOTAUNT', NextTaunt, 5);
	}
	
	if (Other.bIsPlayer) 
        {
		Other.PlayerReplicationInfo.Deaths -= 1;
		if (Other.PlayerReplicationInfo.Deaths < 1)
			BroadcastMessage(Other.PlayerReplicationInfo.PlayerName$" is Out!", true, 'CriticalEvent');
		CheckPlayerTotal();
		CheckEndGame();
	}
	
	CheckMonsterTotal();
}
}
function BroadCastMultiKill(Pawn Killer,int num) 
{
	
	if(Killer.bIsPlayer && !Killer.IsA('Bot'))
		BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName@GetMultiKillText(num));
}
function string GetMultiKillText(int num) 
{
	
	switch (num) 
        {
		case 1:
			return "has Double Kill!";
			break;
		case 2:
			return "has Triple Kill!";
			break;
		case 3:
			return "has Multi Kill!";
			break;
		case 4:
			return "has Mega Kill!!";
			break;
		case 5:
			return "has ULTRA KILL!!";
			break;
		case 6:
		case 7:
		case 8:
			return "has M O N S T E R  K I L L !!!";
			break;
		case 9:
		case 10:
		case 11:
		case 12:
			return "has L U D I C R O U S  K I L L !!!!";
			break;
		case 13:
		case 14:
		case 15:
		case 16:
		case 17:
			return "has H  O  L  Y   S  H  I  T  !!!!!";
			break;
		case 18:
		case 19:
		case 20:
		case 21:
		case 22:
		case 23:
			return "is U  N  R  E  A  L  !!!!!!";
			break;
	}
	return "";
}

// ========================================
// ScoreKill.
function ScoreKill(Pawn Killer, Pawn Other) 
{
	
	Super(GameInfo).ScoreKill(Killer, Other);
	
	if (Other.bIsPlayer)
		Other.PlayerReplicationInfo.Deaths -= 1;
	CheckPlayerTotal();
	
	if(Other != None && !Other.IsA('ScriptedPawn'))
		return;
	
	if (Killer != None)
		BroadcastMessage(Killer.GetHumanName()@"killed"$Other.GetHumanName());
	
	CheckMonsterTotal();
}

// ========================================
// StartMatch.
function StartMatch() 
{
	
	local ScriptedPawn S;
	
	foreach AllActors(class'ScriptedPawn', S) 
        {
		if (!S.IsA('Nali') && !S.IsA('Cow'))
			S.AttitudeToPlayer = ATTITUDE_Hate;
	}
	
	Super.StartMatch();
}

// ========================================
// AddToTeam.
function AddToTeam(int Num, Pawn Other) 
{
	
	local TeamInfo aTeam;
	local Pawn P;
	local bool bSuccess;
	local String SkinName, FaceName;
	
	if (Other != None) 
        {
		aTeam = Teams[0];
		aTeam.Size++;
		Other.PlayerReplicationInfo.Team = 0;
		Other.PlayerReplicationInfo.TeamName = aTeam.TeamName;
		bSuccess = false;
		if (Other.IsA('PlayerPawn')) 
                {
			Other.PlayerReplicationInfo.TeamID = 0;
			PlayerPawn(Other).ClientChangeTeam(Other.PlayerReplicationInfo.Team);
		} 
                else 
                {
			Other.PlayerReplicationInfo.TeamID = 1;
		}
		
		while (!bSuccess) 
                {
			bSuccess = true;
			for (P = Level.PawnList; P != None; P = P.NextPawn) 
                        {
				if (P.bIsPlayer && (P != Other)
					&& (P.PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team)
					&& (P.PlayerReplicationInfo.TeamId == Other.PlayerReplicationInfo.TeamId)) 
                                        {
					
					Other.PlayerReplicationInfo.TeamID++;
					bSuccess = false;
				}
			}
		}
		
		Other.PlayerReplicationInfo.Deaths = Lives;
		Other.static.GetMultiSkin(Other, SkinName, FaceName);
		Other.static.SetMultiSkin(Other, SkinName, FaceName, 0);
	}
}

// ========================================
// Damage Edit.
function int ReduceDamage
(
	int Damage,
	name DamageType,
	Pawn Injured,
	Pawn InstigatedBy
) 
{
	Super(TeamGamePlus).ReduceDamage(Damage, DamageType, Injured, InstigatedBy);

	if (InstigatedBy != None && Injured != None) 
        {
		if (InstigatedBy != Injured
			&& (InstigatedBy.bIsPlayer || InstigatedBy.IsA('Bot'))
			&& (Injured.bIsPlayer || Injured.IsA('Bot'))) 
                        {
			
			return (Damage * FriendlyFireScale);
		}
		if (InstigatedBy.IsA('ScriptedPawn') && Injured.IsA('ScriptedPawn')) 
                {
			return 0;
		}
		if (InstigatedBy.IsA('ScriptedPawn') && Injured.bIsPlayer)
                {
			if (InstigatedBy.IsA('SkaarjTrooper')) 
                        {
				if (SkaarjTrooper(InstigatedBy).WeaponType != class'SniperRifle')
					Damage *= (1.0 + (Waves[WaveRound - 1].WaveDifficulty / 6));
			}
                        else 
                        {
				Damage *= (1.0 + (Waves[WaveRound - 1].WaveDifficulty / 6));
				// Damage += WaveRound * (1.0 + (Waves[WaveRound - 1].WaveDifficulty / 4));
			}
		}
	}
	
	return Damage;
}

// ========================================
// Tick.DeltaTime
function Tick(float DT) 
{
	
	local ScriptedPawn S;
	local SV_ReplicationInfo ACGRI;
	
	Super(TeamGamePlus).Tick(DT);

	if (bGameEnded)
		return;
	
	ACGRI = SV_ReplicationInfo(GameReplicationInfo);
	if (bWaveProgress) 
        {
		if ((Level.TimeSeconds > NextSpawnTime)
                        && (ACGRI.MonsterTotal < (Waves[WaveRound - 1].SpawnMonsterTotal)))
                        {
			
			SpawnMonster();
			if (ACGRI.MonsterTotal < (ACGRI.PlayerTotal * 2))
				NextSpawnTime = Level.TimeSeconds + 0.2;
			else
				NextSpawnTime = Level.TimeSeconds + 2;
		}
		if (WaveEndTime < Level.TimeSeconds)
			bWaveProgress = false;
	}
	
	CheckPlayerTotal();
}

// End Of Foundation, Code TeamDeathMatch

// Begin Additional Code

// ========================================
// Timer.Monster Spawn, Wave Setting
function Timer() 
{
	
	local Pawn P;
	local SV_ReplicationInfo ACGRI;
	
	Super(TeamGamePlus).Timer();

	if (bGameEnded)
		return;
	
	if (!bFirstChecked) 
        {
		return;
	}
	
	ACGRI = SV_ReplicationInfo(GameReplicationInfo);
	if (bWaveStarting)
        {
                if (!bWaveProgress && ACGRI.MonsterTotal == 0)
                {
			ResetWave();
			return;
		}
	} 
        else 
        {
		SetTimer(1.0, true);
		if (WaveStartCountDown <= 0) 
                {
			bWaveStarting = True;
			BroadcastLocalizedMessage(class'SV_WaveRoundMessage', WaveRound, , None, None);
			WaveEndTime = Level.TimeSeconds + Waves[WaveRound - 1].WaveDuration;
			bWaveProgress = true;
			return;
		}
		BroadcastLocalizedMessage(class'SV_WaveCountDownMessage', WaveStartCountDown - 1, ,None, None);
		WaveStartCountDown--;
	}
}

// ========================================
// Reset Wave.
function ResetWave() 
{
	
	local SV_ReplicationInfo ACGRI;
	local Pawn P;
	
	bWaveStarting = False;
	bFirstBlood = false;
	ACGRI = SV_ReplicationInfo(GameReplicationInfo);
	ACGRI.CurrentWave++;
	WaveRound = ACGRI.CurrentWave;
	
	if (WaveRound > FinalWave) 
        {
		EndGame(MSG_WONGAME);
		return;
	}
	
	log("==================== >>> Wave"@WaveRound@"Start! <<< ====================");

	if (bFirstChecked)
        {
		ResetPlayer();
		BroadcastLocalizedMessage(class'SV_WaveStartingMessage', WaveRound, None, None, ACGRI);
	} 
        else 
        {
		BroadcastLocalizedMessage(class'SV_WaveStartingMessage', WaveRound, None, None, None);
		bFirstChecked = True;
	}
	
	SetWaveMonster();
	WaveStartCountDown = 10;
	SetTimer(5.0, true);
}

// ========================================
// Setting Wave Spawn Monseters.
function SetWaveMonster() 
{
	
	local int i, j;
	
	WaveNumClasses = 0;
	j = 1;
	for (i = 0; i < 16; i++) 
        {
		if ((j & Waves[WaveRound - 1].WaveMask) != 0) 
                {
			WaveMonsterClass[WaveNumClasses] = MonsterClass[i];
			WaveNumClasses++;
		}
		j *= 2;
	}
}

// ========================================
// Timer.SubLogic Spawn Monster.
function SpawnMonster() 
{
	local class<ScriptedPawn> SpawnClass;
	local ScriptedPawn Monster;
	local int NavPoint, NumPoint;
	local UTTeleportEffect PTE;
	local Vector GasbagLoc;
	local SV_ReplicationInfo ACGRI;
	local NavigationPoint NP;   //add
	local SV_SurvivalMonsterController MC;    //add
	
	if (bGameEnded)
		return;
	
	NumPoint = 0;
	NavPoint = Rand(NumSpawnPoint);
	ACGRI = SV_ReplicationInfo(GameReplicationInfo);

	for (NP = Level.NavigationPointList; NP != None; NP = NP.NextNavigationPoint)
        {
		if (NP.IsA('PathNode'))
                {
			if (NumPoint == NavPoint) 
                        {
				if (CheckPawn(NP))
                                {
			SpawnClass = GetMonster(NP.Region.Zone.bWaterZone);
			Monster = Spawn(SpawnClass, , , NP.Location);
			if (Monster != None) 
                        {
				if (Monster.IsA('Gasbag') || Monster.IsA('Warlord')) 
                                {
					GasbagLoc = Monster.Location;
					GasbagLoc.Z +=  128;
					Monster.SetLocation(GasbagLoc);
				}
				if (Monster.IsA('SkaarjSniper')) 
                                {
					SkaarjTrooper(Monster).WeaponType = class'SniperRifle';
					SetWeapon(SkaarjTrooper(Monster));
				} 
                                else if (Monster.IsA('SkaarjTrooper'))
                                {
					SkaarjTrooper(Monster).WeaponType = RandWeapon();
					SetWeapon(SkaarjTrooper(Monster));
				}
				Monster.AttitudeToPlayer = ATTITUDE_Hate;
				PTE = Spawn(class'UTTeleportEffect', Monster, , Monster.Location, Monster.Rotation);
				MC = SV_SurvivalMonsterController(Monster.FindInventoryType(class'SV_SurvivalMonsterController'));
				if (MC == None)
                                {
					MC = Spawn(class'SV_SurvivalMonsterController', Monster, 'SV_SurvivalMonsterController', Monster.Location, Monster.Rotation);
					if (MC != None)
                                        {
						MC.bHeldItem = True;
						MC.RespawnTime = 0.0;
						MC.GiveTo(Monster);
						MC.MonsterOwner = Monster;
						MC.Activate();
					}
				}
				Monster.GotoState('Attacking');
					}
				}
				return;
			} 
                        else 
                        {
				NumPoint++;
			}
		}
	}
	return;
}
// ========================================
// Timer.SubLogic Get Monster Classes.
function class<ScriptedPawn> GetMonster(optional bool bWaterZone) 
{
	local class<ScriptedPawn> RetClass;

	if (bWaterZone)
		return class'Slith';
	
	RetClass = WaveMonsterClass[Rand(WaveNumClasses)];
	
	if (RetClass == class'SkaarjSniper') 
        {
		if (FRand() > 0.65)
			return RetClass;
		else
			RetClass = class'SkaarjTrooper';
	}
	if (RetClass == class'LesserBrute')
        {
		if (FRand() > 0.50)
			return RetClass;
		else
			RetClass = class'SVcyborg';
	}
	if (RetClass == class'SkaarjTrooper') 
        {
		switch(Rand(4)) 
                {
			case 0 :
				return class'SkaarjInfantry';
				break;
			case 1 :
				return class'SkaarjGunner';
				break;
			case 2 :
				return class'SkaarjOfficer';
				break;
			default :
				return class'SkaarjTrooper';
				break;
		}
	} 
        else if (RetClass == class'Gasbag')
        {
                switch(Rand(4))
                {
			case 0 :
				return class'Gasbag';
				break;
			case 1 :
				return class'GiantGasbag';
				break;
			case 2 :
				return class'GiantManta';
				break;
			default :
				return class'SVManta';
				break;
		}

	}
	else if (RetClass == class'Krall')
        {
                switch(Rand(5))
                 {
                        case 0 :
				return class'Spinner.Spinner';
				break;
			case 1 :
				return class'SVPredator';
				break;
			case 2 :
				return class'CaveManta';
				break;
			case 3 :
				return class'Manta';
				break;
			default :
				return class'Krall';
				break;
		}
        }
        else if (RetClass == class'KrallElite')
        {
            switch(Rand(4))
                {
                 case 0 :
                            return class'KrallElite';
		   	    break;
		 case 1 :
			    return class'SVEant';
			    break;
		 case 2 :
			    return class'SciKrall';
			    break;
		 default :
		   	    return class'SVmaiden';
			    break;
		}
         }
        else if (RetClass == class'Slith')
        {
		if (FRand() > 0.5)
			return class'LavaSlith';
		else
			return RetClass;
	}
	else if (RetClass == class'Brute')
        {
		if (FRand() > 0.5)
			return class'SVQueen2';
		else
			return RetClass;
	}
        else if (RetClass == class'SkaarjWarrior')
        {
		if (FRand() > 0.5)
			return class'IceSkaarj';
		else
			return RetClass;
	} 
        else if (RetClass == class'Mercenary')
        {
		if (FRand() > 0.85)
			return class'MercenaryElite';
		else
			return RetClass;
	}
        else if (RetClass == class'Behemoth')
        {
		switch(Rand(5))
                {
			case 0 :
				return class'SVQueen';
				break;
			case 1 :
				return class'Behemoth';
				break;
			case 2 :
				return class'Warlord';
				break;
			case 3 :
				return class'Warlord';
				break;
			default :
				return class'Behemoth';
				break;
		}
	}
        else if (RetClass == class'WarLord')
        {
		switch(Rand(5))
                {
			case 0 :
				return class'StoneTitan';
				break;
			case 1 :
				return class'Titan';
				break;
			case 2 :
				return class'LavaTitan';
				break;
			case 3 :
				return class'WaterTitan';
				break;
			default :
				return class'Warlord';
				break;
		}
	}
	else if (RetClass == class'Pupae')
        {
		switch(Rand(4))
                {
			case 0 :
				return class'Fly';
				break;
			case 1 :
				return class'SVshadow';
				break;
			case 2 :
				return class'SVKrallElite';
				break;
			default :
				return class'Pupae';
				break;
		}
	}
	return RetClass;
}

// ========================================
// Random Set Skaarj Troopers Weapon Classes.
function class<Weapon> RandWeapon() 
{
	
	local int Num;
	
	Num = Rand(17);
	if ((TrooperWeapons[Num] == class'SniperRifle') && (FRand() < 0.75))
		Num = Rand(17);
	
	return TrooperWeapons[Num];
}

// ========================================
// Spawn and Setting Skaarj Troopers Weapon.
function SetWeapon(SkaarjTrooper ST) 
{

	local Weapon W;

	if (ST.WeaponType != None) 
        {
		W = Spawn(ST.WeaponType);
		if (W != None) 
                {
			if (W.IsA('SniperRifle'))
				ST.Health = 100;
			W.GiveTo(ST);
			W.WeaponSet(ST);
			ST.myWeapon = W;
		}
	}
}

// ========================================
// Create Randomize Location, Base Location
function Vector RandLoc(Vector BaseLoc) 
{
	
	Local Vector RetLoc;
	
	RetLoc = BaseLoc;
	if (FRand() < 0.75) 
        {
		RetLoc.X += Rand(150);
		RetLoc.Y += Rand(150);
	} 
        else if (FRand() < 0.5) 
        {
		RetLoc.X -= Rand(150);
		RetLoc.Y -= Rand(150);
	} 
        else if (FRand() < 0.25)
        {
		RetLoc.X += Rand(150);
		RetLoc.Y -= Rand(150);
	} 
        else
        {
		RetLoc.X -= Rand(150);
		RetLoc.Y += Rand(150);
	}
	
	return RetLoc;
}

// ========================================
// Checking Game Stats.
function CheckEndGame() 
{
	
	local Pawn P;
	local int LivePL;
	
	if (bGameEnded)
		return;
	
	LivePL = 0;
	for (P = Level.PawnList; P != None; P = P.NextPawn)
		if (P.bIsPlayer)
			if ((P.PlayerReplicationInfo.Deaths >= 1) && !P.PlayerReplicationInfo.bIsSpectator)
				LivePL++;
	
	if (LivePL < 1)
		EndGame(MSG_NOPLAYER);
}


// ========================================
// Calc Count ScriptedPawn Member.
function CheckMonsterTotal() 
{
	
	local SV_ReplicationInfo ACGRI;
	local ScriptedPawn S;
	
	ACGRI = SV_ReplicationInfo(GameReplicationInfo);
	ACGRI.MonsterTotal = 0;
	foreach AllActors(class'ScriptedPawn', S) 
        {
		ACGRI.MonsterTotal++;
	}
}



// ========================================
// Calc Count Player ant Bot.
function CheckPlayerTotal()
{
	
	local SV_ReplicationInfo ACGRI;
	local Pawn P;
	
	ACGRI = SV_ReplicationInfo(GameReplicationInfo);
	ACGRI.PlayerTotal = 0;
	ACGRI.MonsterTotal = 0;
	ACGRI.OnlinePlayerTotal = 0;
	for (P = Level.PawnList; P != None; P = P.NextPawn) 
        {
		if (P.IsA('PlayerPawn'))
                {
			ACGRI.OnlinePlayerTotal++;
			if (P.PlayerReplicationInfo.Deaths >= 1 && (!P.bHidden || !P.PlayerReplicationInfo.bIsSpectator))
                        {
				ACGRI.PlayerTotal++;
			}
		}
		
                else if (P.IsA('ScriptedPawn'))
                {
			ACGRI.MonsterTotal++;
		}
	}
}

// ========================================
// Reset Player and Bot Condition.
function ResetPlayer()
{
	
	local Pawn P;
	
	for (P = Level.PawnList; P != None; P = P.NextPawn) 
        {
		if (P.IsA('PlayerPawn') && P.bIsPlayer) 
                {                                                       // added check for extra life
                   if (P.PlayerReplicationInfo.Deaths > Lives)
                        {
                                P.PlayerReplicationInfo.Deaths = Lives;
                        }
                   if (P.PlayerReplicationInfo.Deaths < 1)
                        {
				P.PlayerReplicationInfo.Deaths = Lives;
				P.PlayerReplicationInfo.bIsSpectator = false;
				P.PlayerReplicationInfo.bWaitingPlayer = false;
				P.bHidden = false;
				PlayerPawn(P).ViewTarget = None;
				P.bBehindview = false;
				PlayerPawn(P).bShowScores = false;
				P.PlayerRestartState = 'PlayerWalking';
				P.GotoState('');
				if (RestartPlayer(P)) 
                                {
					StartPlayer(PlayerPawn(P));
					PlayerPawn(P).ClientRestart();
				}
			} 
                        else if (!P.bHidden) 
                        {
				ResetWeapon(P);
				if (P.PlayerReplicationInfo.Deaths < Lives)
					P.PlayerReplicationInfo.Deaths += 1;
				if (P.Health < 500)
					P.Health = 500;
			}
		} 
                else if (P.IsA('Bot')) 
                {
			if (P.PlayerReplicationInfo.Deaths < 1) 
                        {
				P.PlayerReplicationInfo.Deaths = Lives;
				P.PlayerReplicationInfo.bIsSpectator = false;
				P.PlayerReplicationInfo.bWaitingPlayer = false;
				P.bHidden = false;
				P.bBehindview = false;
				P.PlayerRestartState = 'PlayerWalking';
				if (RestartPlayer(P)) 
                                {
					Bot(P).RestartPlayer();
					Bot(P).ClientRestart();
				}
				P.GotoState('Attacking');
				P.SetPhysics(PHYS_Walking);
			} 
                        else if (!P.bHidden) 
                        {
				ResetWeapon(P);
				if (P.PlayerReplicationInfo.Deaths < Lives)
					P.PlayerReplicationInfo.Deaths += 1;
				if (P.Health < 500)
					P.Health = 500;
			}
		}

	}
}

// ========================================
// Give AllWeapons.
function ResetWeapon(Pawn PlayerPawn) 
{
	
	local Inventory INV;
	local Weapon W;
	
	GiveWeapon(PlayerPawn, "Botpack.UT_BioRifle");
	GiveWeapon(PlayerPawn, "Botpack.ShockRifle");
	GiveWeapon(PlayerPawn, "Botpack.PulseGun");
	GiveWeapon(PlayerPawn, "Botpack.Ripper");
	GiveWeapon(PlayerPawn, "Botpack.Minigun2");
	GiveWeapon(PlayerPawn, "Botpack.UT_FlakCannon");
	GiveWeapon(PlayerPawn, "Botpack.UT_Eightball");
	GiveWeapon(PlayerPawn, "Botpack.SniperRifle");
//	PlayerPawn.SwitchToBestWeapon();        //nulls the autoswitch
	
	for (INV = PlayerPawn.Inventory; INV != None; INV = INV.Inventory) 
        {
		W = Weapon(INV);
		if ((W != None) && (W.AmmoType != None))
			W.AmmoType.AmmoAmount = W.AmmoType.MaxAmmo;
	}
}

function bool CheckPawn(NavigationPoint node)
{
	
	local Pawn Touching;
	
	if (node.Region.Zone.bPainZone && node.Region.Zone.DamagePerSec > 0)
		return false;
	
	foreach VisibleCollidingActors(class'pawn', Touching, 40, node.Location) 
        {
      		return false;
	}
	
	return true;
}

defaultproperties
{
    MSG_NOPLAYER="No Player"
    MSG_INVASION="You were overwhelmed"
    MSG_DESTROYED="No ControlPoint"
    MSG_TIMEOUT="Time Out"
    MSG_WONGAME="Won the Game"
    START_ROUND=1
    FINAL_ROUND=16
    TimeOutMessage="was able to hold out until reinforcements arrived."
    NoPlayerEndedMessage="There are no survivors..."
    InvasionAllowedMessage="The monsters are victorious!"
    ControlDestroyedMessage="Defense Failure..."
    TrooperWeapons(0)=Class'Survival2.SVenforcer'
    TrooperWeapons(1)=Class'Botpack.minigun2'
    TrooperWeapons(2)=Class'Botpack.PulseGun'
    TrooperWeapons(3)=Class'Botpack.ripper'
    TrooperWeapons(4)=Class'Botpack.ShockRifle'
    TrooperWeapons(5)=Class'Botpack.SniperRifle'
    TrooperWeapons(6)=Class'Botpack.ut_biorifle'
    TrooperWeapons(7)=Class'Botpack.UT_Eightball'
    TrooperWeapons(8)=Class'Botpack.UT_FlakCannon'
    TrooperWeapons(9)=Class'Survival2.SVenforcer'
    TrooperWeapons(10)=Class'Botpack.minigun2'
    TrooperWeapons(11)=Class'Botpack.PulseGun'
    TrooperWeapons(12)=Class'Botpack.ripper'
    TrooperWeapons(13)=Class'Botpack.ShockRifle'
    TrooperWeapons(14)=Class'Botpack.ut_biorifle'
    TrooperWeapons(15)=Class'Botpack.UT_Eightball'
    TrooperWeapons(16)=Class'Botpack.UT_FlakCannon'
    MonsterClass(0)=Class'UnrealI.Pupae'
    MonsterClass(1)=Class'UnrealI.Krall'
    MonsterClass(2)=Class'UnrealI.KrallElite'
    MonsterClass(3)=Class'UnrealI.Gasbag'
    MonsterClass(4)=Class'UnrealShare.Slith'
    MonsterClass(5)=Class'UnrealI.Mercenary'
    MonsterClass(6)=Class'UnrealI.SkaarjTrooper'
    MonsterClass(7)=Class'UnrealI.SkaarjSniper'
    MonsterClass(8)=Class'UnrealShare.SkaarjScout'
    MonsterClass(9)=Class'UnrealShare.SkaarjWarrior'
    MonsterClass(10)=Class'UnrealI.SkaarjAssassin'
    MonsterClass(11)=Class'UnrealI.SkaarjLord'
    MonsterClass(12)=Class'UnrealShare.LesserBrute'
    MonsterClass(13)=Class'UnrealShare.Brute'
    MonsterClass(14)=Class'UnrealI.Behemoth'
    MonsterClass(15)=Class'UnrealI.WarLord'
    Lives=1
    InitialWave=1
    FinalWave=16
    Waves(0)=(WaveMask=4107,SpawnMonsterTotal=16,WaveDuration=90.00,WaveDifficulty=0.00),
    Waves(1)=(WaveMask=4123,SpawnMonsterTotal=16,WaveDuration=90.00,WaveDifficulty=0.00),
    Waves(2)=(WaveMask=47,SpawnMonsterTotal=16,WaveDuration=90.00,WaveDifficulty=0.00),
    Waves(3)=(WaveMask=263,SpawnMonsterTotal=16,WaveDuration=90.00,WaveDifficulty=0.00),
    Waves(4)=(WaveMask=270,SpawnMonsterTotal=16,WaveDuration=90.00,WaveDifficulty=0.50),
    Waves(5)=(WaveMask=13068,SpawnMonsterTotal=16,WaveDuration=90.00,WaveDifficulty=0.50),
    Waves(6)=(WaveMask=8972,SpawnMonsterTotal=12,WaveDuration=120.00,WaveDifficulty=0.50),
    Waves(7)=(WaveMask=26380,SpawnMonsterTotal=12,WaveDuration=120.00,WaveDifficulty=1.00),
    Waves(8)=(WaveMask=9804,SpawnMonsterTotal=12,WaveDuration=120.00,WaveDifficulty=1.00),
    Waves(9)=(WaveMask=12348,SpawnMonsterTotal=12,WaveDuration=120.00,WaveDifficulty=1.00),
    Waves(10)=(WaveMask=27788,SpawnMonsterTotal=12,WaveDuration=180.00,WaveDifficulty=1.50),
    Waves(11)=(WaveMask=20254,SpawnMonsterTotal=12,WaveDuration=180.00,WaveDifficulty=1.50),
    Waves(12)=(WaveMask=34062,SpawnMonsterTotal=12,WaveDuration=180.00,WaveDifficulty=2.00),
    Waves(13)=(WaveMask=36870,SpawnMonsterTotal=12,WaveDuration=180.00,WaveDifficulty=2.00),
    Waves(14)=(WaveMask=47104,SpawnMonsterTotal=8,WaveDuration=180.00,WaveDifficulty=2.50),
    Waves(15)=(WaveMask=49152,SpawnMonsterTotal=8,WaveDuration=300.00,WaveDifficulty=3.00),
    MaxTeams=1
    MaxAllowedTeams=1
    StartUpTeamMessage="Welcome to the Area!"
    FragLimit=0
    bMultiWeaponStay=False
    bUseTranslocator=True
    StartUpMessage="Kill to SURVIVE."
    StartMessage="Can you SURVIVE to the end?"
    GameEndedMessage=" "
    ExplodeMessage=" was blown completely the hell up"
    BurnedMessage=" was utterly incinerated"
    CorrodedMessage=" was slimed to death"
    HackedMessage=" was hacked all up"
    Difficulty=3
    bNoMonsters=False
    ScoreBoardType=Class'SV_ScoreBoard'
    HUDType=Class'SV_SurvivalHUD'
    MapListType=Class'SV_SurvivalMapList'
    MapPrefix="SV"
    BeaconName="SV"
    LeftMessage=" did not survive."
    EnteredMessage=" entered the game."
    GameName="UT Survival"
    MutatorClass=Class'SV_BaseMutator'
    GameReplicationInfoClass=Class'SV_ReplicationInfo'
}
