//=============================================================================
// SVMutators
// A master mutator to load all optional Survival mutators
//=============================================================================

class SVMutators expands Mutator config(Survival2);

var() globalconfig bool bUseSpawnProt;
var() globalconfig int SpawnProtDuration;

var() globalconfig bool bFragBonus;    // Bonus ammo&health for frags
var() globalconfig bool bOneUp;      // Free life artifact
var() globalconfig bool bInvincible;    // Invincible artifact
var() globalconfig bool bDamageScore;    // Score from damage mut
//var() globalconfig bool

var bool Initialized;
var Mutator SpawnProt;
var Mutator SV_FragBonus;
var Mutator SV_OneUpRelic;
var Mutator SV_InvincibleRelic;
var Mutator SV_DamageMutator;

function PostBeginPlay()
{
        if (Initialized)
                return;
        Initialized = True;
// SpawnProt
        Level.Game.RegisterDamageMutator(Spawn(class'SpawnProt'));
// Frag Bonus
        if (bFragBonus == True)
        {
            Level.Game.BaseMutator.AddMutator(Level.Spawn(class'SV_FragBonus'));
        }
// Free life Relic
        if (bOneUp == True)
        {
            Level.Game.BaseMutator.AddMutator(Level.Spawn(class'SV_OneUpRelic'));
        }
// Invincible Relic
        if (bInvincible == True)
        {
            Level.Game.BaseMutator.AddMutator(Level.Spawn(class'SV_InvincibleRelic'));
        }
// Damage becomes Score
        if (bDamageScore == True)
        {
            Level.Game.BaseMutator.AddMutator(Level.Spawn(class'SV_DamageMutator'));
        }

// Blank class container
//        Level.Game.RegisterDamageMutator(Spawn(class ''));
// HUD container
//       Level.Game.BaseMutator.AddMutator(Spawn(Class<Mutator>(DynamicLoadObject("Survival2.*****HUDMutator", class'Class'))));

}

function ModifyPlayer(Pawn Other)
{
     local Inventory Inv;
     local Ammo A;

//SpawnProtEffect
        if (bUseSpawnProt)
        {
          Inv = Other.FindInventoryType(class'SpawnProtEffect');
          if ( Inv != None )
               SpawnProtEffect(Inv).Duration = SpawnProtDuration;
          else
          {
               inv = Spawn(class'SpawnProtEffect');
               if( inv != None )
               {
                    SpawnProtEffect(Inv).Duration = SpawnProtDuration;
                    inv.GiveTo(Other);
                    inv.Activate();
               }
          }
        }

     if ( NextMutator != None )
          NextMutator.ModifyPlayer(Other);
}

defaultproperties
{
     bUseSpawnProt=True
     SpawnProtDuration=5
     bFragBonus=True
     bOneUp=True
     bInvincible=True
     bDamageScore=True
}
