

#exec Audio Import File="Sounds\ShieldPack.wav" Name="ShieldPack"
#exec TEXTURE IMPORT NAME=SVarmor FILE=textures\SVarmor.PCX

class SV_Armor extends TournamentPickup
	abstract;

function bool HandlePickupQuery(Inventory Item) 
{
	
	local Inventory I, S;
	
	if (Item.class == class) 
        {
		
		// remove other armors
		for (I = Owner.Inventory; I != None; I = I.Inventory) 
                {
			if (I.bIsAnArmor && (I != self)) 
                        {
				Charge += I.Charge;
				I.Destroy();
				if (Charge > 400)
					Charge = 400;
			} else if (I.bIsAnArmor && (I == self)) 
                        {
				Charge += self.Default.Charge;
				if (Charge > 400)
					Charge = 400;
			}
		}
		
		if (Level.Game.LocalLog != None)
			Level.Game.LocalLog.LogPickup(Item, Pawn(Owner));
		if (Level.Game.WorldLog != None)
			Level.Game.WorldLog.LogPickup(Item, Pawn(Owner));
		if ( PickupMessageClass == None )
			Pawn(Owner).ClientMessage(PickupMessage, 'Pickup');
		else
			Pawn(Owner).ReceiveLocalizedMessage(PickupMessageClass, 0, None, None, Self.Class);
		Item.PlaySound (PickupSound, , 2.0);
		Item.SetReSpawn();
		return true;				
	}
	
	if (Inventory == None)
		return false;
	
	return Inventory.HandlePickupQuery(Item);
}

function ArmorImpactEffect(Vector HitLocation) 
{

	if (Owner.IsA('PlayerPawn')) 
        {
		PlayerPawn(Owner).ClientFlash(-0.05, vect(400, 400, 400));
		PlayerPawn(Owner).PlaySound(DeActivateSound, SLOT_None, 2.7*PlayerPawn(Owner).SoundDampening);
	}
}

defaultproperties
{
    bDisplayableInv=True
    ItemName="ShieldPack"
    ArmorAbsorption=80
    bIsAnArmor=True
    AbsorptionPriority=10
    MaxDesireability=3.00
    PickupSound=Sound'ShieldPack'
    DeActivateSound=Sound'UnrealShare.Pickups.Sbelthe2'
    Icon=Texture'UnrealShare.Icons.I_ShieldBelt'
    bOwnerNoSee=True
    RemoteRole=1
    Style=3
    MultiSkins(1)=Texture'SVarmor'
    CollisionRadius=25.00
    CollisionHeight=10.00
}
