class SV_BaseMutator extends Mutator config(SV_RPG);

//game vars:
var DeathMatchPlus MyGame;
var bool bInit;

function PostBeginPlay() 
{

MyGame = DeathMatchPlus(Level.Game);

Super.PostBeginPlay();

}

// ========================================
// PreCache Monster Meshes.
function PreCacheReferences() 
{
	
	//never called - here to force precaching of meshes
	Spawn(class'UnrealShare.Fly');
	Spawn(class'UnrealShare.Manta');
	Spawn(class'UnrealShare.CaveManta');
	Spawn(class'UnrealI.GiantManta');
	Spawn(class'UnrealI.Pupae');
	Spawn(class'UnrealI.Gasbag');
	Spawn(class'UnrealI.GiantGasbag');
	Spawn(class'UnrealShare.Slith');
	Spawn(class'UnrealI.Krall');
	Spawn(class'UnrealI.KrallElite');
	Spawn(class'UnrealI.Mercenary');
	Spawn(class'UnrealI.MercenaryElite');
	Spawn(class'UnrealShare.LesserBrute');
	Spawn(class'UnrealShare.Brute');
	Spawn(class'UnrealI.Behemoth');
	Spawn(class'UnrealShare.SkaarjWarrior');
	Spawn(class'UnrealShare.SkaarjScout');
	Spawn(class'UnrealI.IceSkaarj');
	Spawn(class'UnrealI.SkaarjAssassin');
	Spawn(class'UnrealI.SkaarjLord');
	Spawn(class'UnrealI.SkaarjBerserker');
	Spawn(class'UnrealI.SkaarjTrooper');
	Spawn(class'UnrealI.SkaarjInfantry');
	Spawn(class'UnrealI.SkaarjGunner');
	Spawn(class'UnrealI.SkaarjOfficer');
	Spawn(class'UnrealI.SkaarjSniper');
	Spawn(class'UnrealShare.DevilFish');
	Spawn(class'UnrealI.Titan');
	Spawn(class'UnrealI.StoneTitan');
	Spawn(class'UnrealI.WarLord');
	Spawn(class'UnrealI.Queen');

}

function bool AlwaysKeep(Actor Other) 
{
	
	local Mover mov;
	local bool bExists;
	
	if (Other.IsA('TournamentPlayer') || Other.IsA('Bot')) 
        {
		Pawn(Other).PlayerReplicationInfoClass = class'SV_PlayerInfo';
		return true;
	}
	
	if (Other.IsA('ScriptedPawn')) 
        {
		if (Other.IsA('SkaarjTrooper')) 
                {
			SkaarjTrooper(Other).WeaponType = None;
			SkaarjTrooper(Other).myWeapon = None;
		}
		if (Other.IsA('Pupae'))
			Pawn(Other).Health = 60;
		if (Other.IsA('Krall')) 
                {
			if (Other.Style == STY_Normal)
				Other.Style = STY_Masked;
		}
		if (Other.IsA('Slith'))
                {
			if (Other.Style == STY_Normal)
				Other.Style = STY_Masked;
			ScriptedPawn(Other).RangedProjectile = class'SV_SlithProj';
		}
		if (Other.IsA('Mercenary')) 
                {
			ScriptedPawn(Other).RangedProjectile = class'SV_MercRocket';
		}
		if (Other.IsA('SkaarjWarrior'))
                {
			if (Other.Style == STY_Normal)
				Other.Style = STY_Masked;
			ScriptedPawn(Other).RangedProjectile = class'QueenProjectile';
			if (Other.IsA('SkaarjScout'))
                        {
				ScriptedPawn(Other).RangedProjectile = class'SkaarjProjectile';
			}
			if (Other.IsA('IceSkaarj')) 
                        {
				ScriptedPawn(Other).RangedProjectile = class'PlasmaSphere';
			}
			if (Other.IsA('SkaarjAssassin')) 
                        {
				ScriptedPawn(Other).RangedProjectile = class'DAmmo2';
			}
			if (Other.IsA('SkaarjLord')) 
                        {
				ScriptedPawn(Other).RangedProjectile = class'DAmmo3';
			}
		}
		if (Other.IsA('Brute')) 
                {
			ScriptedPawn(Other).RangedProjectile = class'SV_BruteRocket';
		}
		if (Other.IsA('Warlord'))
                {
			if (Other.Style == STY_Normal)
				Other.Style = STY_Masked;
			ScriptedPawn(Other).RangedProjectile = class'SV_WarlordRocket';
		}
		return true;
	}
	
	if (Other.IsA('Mover')) 
        {
		if (Mover(Other).InitialState == 'BumpOpenTimed'
			|| Mover(Other).InitialState == 'StandOpenTimed')
			Mover(Other).BumpType = BT_PawnBump;
	}
	
	bExists = false;
	if (Other.IsA('Trigger')) 
        {
		foreach AllActors (class'Mover', mov, Other.Event)
			bExists = True;
		if (bExists && Trigger(Other).TriggerType == TT_PlayerProximity)
			Trigger(Other).TriggerType = TT_PawnProximity;
		return true;
	}
	
	if (NextMutator != None)
		return (NextMutator.AlwaysKeep(Other));
	
	return false;
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant) 
{
	
	local Inventory Inv;
	
	bSuperRelevant = 1;
	
	if (MyGame.bMegaSpeed && Other.bIsPawn && Pawn(Other).bIsPlayer) 
        {
		Pawn(Other).GroundSpeed *= 1.4;
		Pawn(Other).WaterSpeed *= 1.4;
		Pawn(Other).AirSpeed *= 1.4;
		Pawn(Other).AccelRate *= 1.4;
	}
	
	Inv = Inventory(Other);
	
 	if (Inv == None) 
         {
		bSuperRelevant = 0;
		if (Other.IsA('TorchFlame'))
			Other.NetUpdateFrequency = 0.5;
		return true;
 	}
 	
 	// Inv.RespawnTime = 1;
	
	if (Other.IsA('Weapon')) 
        {
		
		if (Other.IsA('TournamentWeapon'))
			return true;
		
		if (Other.IsA('Stinger')) 
                {
			ReplaceWith(Other, "Botpack.PulseGun");
			return false;
		}
		
		if (Other.IsA('Rifle')) 
                {
			ReplaceWith(Other, "Botpack.SniperRifle");
			Return false;
		}
		
		if (Other.IsA('Razorjack')) 
                {
			ReplaceWith(Other, "Botpack.Ripper");
			Return false;
		}
		
		if (Other.IsA('Minigun')) 
                {
			ReplaceWith(Other, "Botpack.Minigun2");
			return false;
		}
		if (Other.IsA('Enforcer') && !Other.Isa('SVEnforcer'))
                {
			ReplaceWith(Other, "Survival2.SVEnforcer");
			return false;
		}
		
		if (Other.IsA('Eightball')) 
                {
			ReplaceWith(Other, "Botpack.UT_Eightball");
			return false;
		}
		
		if (Other.IsA('FlakCannon')) 
                {
			ReplaceWith(Other, "Botpack.UT_FlakCannon");
			return false;
		}
		
		if (Other.IsA('ASMD')) 
                {
			ReplaceWith(Other, "Botpack.ShockRifle");
			return false;
		}
		
		if (Other.IsA('GesBioRifle'))
                {
			ReplaceWith(Other, "Botpack.UT_BioRifle");
			return false;
		}
		
		if (Other.IsA('DispersionPistol')) 
                {
			ReplaceWith(Other, "Botpack.ImpactHammer");
			return false;
		}
		
		bSuperRelevant = 0;
		return true;
	}
	
	if (Other.IsA('Pickup')) 
        {
		Pickup(Other).bAutoActivate = true;
		if (Other.IsA('TournamentPickup')) 
                {
			
			if (Other.IsA('ThighPads')) 
                        {
				ReplaceWith(Other, "Survival2.SV_ShieldPackMini");
				return false;
			}
			
			if (Other.IsA('Armor2')) 
                        {
				ReplaceWith(Other, "Survival2.SV_MidShieldPack");
				return false;
			}
			
			if (Other.IsA('UT_ShieldBelt')) 
                        {
				ReplaceWith(Other, "Survival2.SV_SuperShieldPack");
				return false;
			}
			return true;
		}
	}
	
	if (Other.IsA('TournamentHealth')) 
        {
		
		if (Other.IsA('MedBox'))
                {
			ReplaceWith(Other, "Survival2.SV_MedBox");
			return false;
		}
		
		if (Other.IsA('HealthPack')) 
                {
			ReplaceWith(Other, "Survival2.SV_HealthPack");
			return false;
		}
		
		if (Other.IsA('HealthVial')) 
                {
			ReplaceWith(Other, "Survival2.SV_HealthVial");
			return false;
		}
	}
	
	if (Other.IsA('Ammo')) 
        {
		
		if (Other.IsA('TournamentAmmo'))
			return true;
		
		if (Other.IsA('ASMDAmmo')) 
                {
			ReplaceWith(Other, "Botpack.ShockCore");
			return false;
		}
		if (Other.IsA('RocketCan')) 
                {
			ReplaceWith(Other, "Botpack.RocketPack");
			return false;
		}
		if (Other.IsA('StingerAmmo')) 
                {
			ReplaceWith(Other, "Botpack.PAmmo");
			return false;
		}
		if (Other.IsA('RazorAmmo')) 
                {
			ReplaceWith(Other, "Botpack.BladeHopper");
			return false;
		}
		if (Other.IsA('RifleRound'))
                {
			ReplaceWith(Other, "Botpack.RifleShell");
			return true;
		}
		if (Other.IsA('RifleAmmo')) 
                {
			ReplaceWith(Other, "Botpack.BulletBox");
			return false;
		}
		if (Other.IsA('FlakBox')) 
                {
			ReplaceWith(Other, "Botpack.FlakAmmo");
			return false;
		}
		if (Other.IsA('Clip')) 
                {
			ReplaceWith(Other, "Botpack.EClip");
			return false;
		}
		if (Other.IsA('ShellBox')) 
                {
			ReplaceWith(Other, "Botpack.MiniAmmo");
			return false;
		}
		if (Other.IsA('Sludge')) 
                {
			ReplaceWith(Other, "Botpack.BioAmmo");
			return false;
		}
		
		bSuperRelevant = 0;
		return true;
	}
		
	if (Other.IsA('Invisibility')) 
        {
		ReplaceWith(Other, "Botpack.UT_Invisibility");
		return false;
	}
	if (Other.IsA('JumpBoots')) 
        {
		if (MyGame.bJumpMatch)
			return false;
		ReplaceWith(Other, "Botpack.UT_JumpBoots");
		return false;
	}
	if (Other.IsA('Amplifier')) 
        {
		ReplaceWith(Other, "Botpack.UDamage");
		return false;
	}
	if (Other.IsA('WeaponPowerUp'))
		return false; 
	if (Other.IsA('ShieldBelt')) 
        {
		ReplaceWith(Other, "Survival2.SV_SuperShieldPack");
		return false;
	}
	if (Other.IsA('Suits')) 
        {
		ReplaceWith(Other, "Survival2.SV_ShieldPackMini");
		return false;
	}
	if (Other.IsA('Armor')) 
        {
		ReplaceWith(Other, "Survival2.SV_MidShieldPack");
		return false;
	}
	if (Other.IsA('Bandages')) 
        {
		ReplaceWith(Other, "Survival2.SV_HealthVial");
		return false;
	}
	if (Other.IsA('SuperHealth')) 
        {
		ReplaceWith(Other, "Survival2.SV_HealthPack");
		return false;
	}
	if (Other.IsA('Health') && !Other.IsA('SuperHealth') && !Other.IsA('Bandages')) 
        {
		ReplaceWith(Other, "Survival2.SV_MedBox");
		return false;
	}
	if (Other.IsA('Pylon'))
	{
	       return true;
        }

	bSuperRelevant = 0;
	return true;
}

function ModifyPlayer(Pawn P)
{
	Super.ModifyPlayer(P);

	if (MyGame.IsA('SurvivalGame'))
		bInit = SurvivalGame(MyGame).bMutateInitFor;

	if (!bInit) 
        {
		if (MyGame.IsA('SurvivalGame'))
			SurvivalGame(MyGame).bMutateInitFor = true;
		SetTimer(10.0, false);   // was 20
	}
}

function Timer()
{
		if (MyGame.IsA('SurvivalGame'))
		SurvivalGame(MyGame).ResetWave();
}



defaultproperties
{
}
