

class SV_EndTeamKillingMessage extends LocalMessagePlus;

var localized string MonsterEndString;
var localized string PlayerEndString;
var localized string TotalVictimString;

static function float GetOffset(int Switch, float YL, float ClipY) {
	
	return (Default.YPos / 768.0) * ClipY - 2 * YL;
}

static function string GetString(
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject 
) {
	if (RelatedPRI_2 != None) 
        {
		if (RelatedPRI_1 != None) 
                {
			// Player
			if (RelatedPRI_1.PlayerName != "" && RelatedPRI_2.PlayerName != "")
				return RelatedPRI_2.PlayerName@Default.PlayerEndString@RelatedPRI_1.PlayerName$Default.TotalVictimString@Switch;
		} 
                else 
                {
			// Monster
			if (RelatedPRI_2.PlayerName != "")
				return RelatedPRI_2.PlayerName@Default.MonsterEndString$Default.TotalVictimString@Switch;
		}
	} 
        else 
        {
		// Suicide
		if (RelatedPRI_1.PlayerName != "")
			return RelatedPRI_1.PlayerName@Default.PlayerEndString@RelatedPRI_1.PlayerName$"? LOL"$Default.TotalVictimString@Switch;
	}

	return "";
}

static simulated function ClientReceive( 
	PlayerPawn P,
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
) 
{
	Super.ClientReceive(P, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
	
	P.ClientPlaySound(sound'SpreeSound', , true);
}

defaultproperties
{
    MonsterEndString="was killed by Monsters"
    PlayerEndString="was killed by"
    TotalVictimString=". Total Victim :"
    FontSize=2
    bIsSpecial=True
    bIsUnique=True
    bFadeMessage=True
    DrawColor=(R=255,G=0,B=0,A=0),
    YPos=196.00
    bCenter=True
}
