// Damage mutator for Survival
//
// This mutator lets the server admin control the health and ammo regain.
// The damage taken goes into Health and Ammo by a factor defined in the ini file.

class SV_FragBonus extends Mutator config (Survival2);

var config bool bRegenHealth, bRegenAmmo;
var config float HealthFactor, AmmoFactor;
var config int MaxHealth, MaxAmmo;
var bool Init;

function PostBeginPlay()
{
	if (Init)
		return;
	Init = True;

	Level.Game.RegisterDamageMutator(Self);
}

function MutatorTakeDamage( out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
local int AddHealth, AddAmmo;
local TournamentAmmo Inv;// Inventory

if (Victim != None)
  {
     if ( (InstigatedBy != None) && InstigatedBy.IsA('PlayerPawn'))
	{
	if ( bRegenHealth )
		{
		if (Victim.IsA('ScriptedPawn') && InstigatedBy.bIsPlayer)
			{
			AddHealth = ActualDamage * HealthFactor;
			InstigatedBy.Health += AddHealth;
			if ( InstigatedBy.Health > MaxHealth )
				{
				InstigatedBy.Health = MaxHealth;
				}
			}
		}
	if ( bRegenAmmo )
		{
		AddAmmo = ActualDamage * AmmoFactor;

		InstigatedBy.Weapon.AmmoType.AmmoAmount += AddAmmo;
		if ( InstigatedBy.Weapon.AmmoType.AmmoAmount > MaxAmmo )
			{
			InstigatedBy.Weapon.AmmoType.AmmoAmount = MaxAmmo;
			}
		}
	}
if ( NextDamageMutator != None )
	{
	NextDamageMutator.MutatorTakeDamage( ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);
	}
  }
}
defaultproperties
{	
}

