

#exec Texture Import File="Textures\SV_End.bmp" Name=SV_End Mips=Off Flags=2

class SV_GameEnd expands Trigger;

var String MSG_INVASION;		// value = "Invasion Allowed"

function PostBeginPlay()
{
	
	local int i;
	
	super.PostBeginPlay();
	
	for (i = 0; i < 10; i++) 
        {
		log("==================== >> DO NOT USE !! << ====================");
		log("||           Error Message From SV_GameEnd Class           ||");
		log("=============================================================");
	}
}

function Touch(actor Other) 
{
	
	local actor A;
	
	if(IsRelevant(Other)) 
        {
		if (ReTriggerDelay > 0) 
                {
			if (Level.TimeSeconds - TriggerTime < ReTriggerDelay)
				return;
			TriggerTime = Level.TimeSeconds;
		}
		
		// Broadcast the Trigger message to all matching actors.
		if(Event != '')
			foreach AllActors(class 'Actor', A, Event)
				A.Trigger(Other, Other.Instigator);
		
		if (Other.IsA('Pawn') && (Pawn(Other).SpecialGoal == self))
			Pawn(Other).SpecialGoal = None;

		// Send a string message to the toucher.
		if(Message != "")
			Other.Instigator.ClientMessage(Message);
		
		TouchMonster();
		
		// Ignore future touches.
		if(bTriggerOnceOnly) 
                {
			SetCollision(False);
		} else if (RepeatTriggerTime > 0) 
                {
			SetTimer(RepeatTriggerTime, false);
		}
	}
}

function TakeDamage
(
	int Damage,
	Pawn InstigatedBy,
	Vector HitLocation,
	Vector Momentum,
	Name DamageType
) 
{
	local actor A;
	
	if (bInitiallyActive && (TriggerType == TT_Shoot)
		&& (Damage >= DamageThreshold) && (InstigatedBy != None)) 
                {
		
		if (ReTriggerDelay > 0) 
                {
			if (Level.TimeSeconds - TriggerTime < ReTriggerDelay)
				return;
			TriggerTime = Level.TimeSeconds;
		}
		
		// Broadcast the Trigger message to all matching actors.
		if(Event != '')
			foreach AllActors(class 'Actor', A, Event)
				A.Trigger(InstigatedBy, InstigatedBy);
		
		// Send a string message to the toucher.
		if(Message != "")
			InstigatedBy.Instigator.ClientMessage(Message);
		
		// Ignore future touches.
		if( bTriggerOnceOnly )
			SetCollision(False);
		
		// Survival - Ended
		TouchMonster();
	}
}

function TouchMonster() 
{
	
	local SurvivalGame AC;
	
	AC = SurvivalGame(Level.Game);
	if (AC != None)
		AC.EndGame(MSG_INVASION);
}

defaultproperties
{
    MSG_INVASION="Invasion Allowed"
    TriggerType=2
    ClassProximityType=Class'UnrealShare.ScriptedPawn'
    Texture=Texture'SV_End'
    CollisionRadius=256.00
    CollisionHeight=256.00
}
