// Base HUD

#exec Texture Import File=Textures\Radar.bmp Name=Radar Group=RadarBase Maps=Off Flags=2
#exec Texture Import File=Textures\RadarBorder.bmp Name=RadarBorder Group=RadarBase Maps=Off Flags=2
#exec Texture Import File=Textures\Dots.bmp Name=Dots Group=RadarBase Maps=Off Flags=2
#exec Texture Import File=Textures\crossm.bmp Name=crossm Group=RadarBase Maps=Off Flags=2
#exec Texture Import File=Textures\StatElement.bmp Name=StatElement Maps=On Flags=2

class SV_HUD expands ChallengeTeamHUD;

var color LightCyanColor, RadarColor, HUDelementColor;
var float LastDrawRadar, RadarScale, RadarPosX, RadarPosY, RadarPulse;

// custom vars:
var string ShowWeapon;
var int ShowArmor, ShowAmmo, CycleR, CycleG, CycleB, CycleColorR, CycleColorG, CycleColorB, ColorStepR, ColorStepG, ColorStepB;
var SV_ReplicationInfo SVGRI;
// statistic vars:
var bool bShowStats;				//Display Stats On/Off
var string P1,P2,P3,P4,P5,P6,P7,P8,P9,P10;	//Playernames
var int S1,S2,S3,S4,S5,S6,S7,S8,S9,S10;		//Score
var int G1,G2,G3,G4,G5,G6,G7,G8,G9,G10;		//Games
var int UpDown, StatCount, Fade, WaitTime;


simulated function PostBeginPlay() 
{
	
	Super.PostBeginPlay();
}

simulated function PostRender(Canvas C) 
{
	
	local int X, Y;
	local float XL, YL;
	local Pawn P;
	
	Super.PostRender(C);
	
	if (bHideHud
		|| ((C.ClipX <= 400) && ((PlayerPawn(Owner).bShowScores) || bForceScores))) 
                {
		return;
	        }
	
	if (TournamentConsole(PlayerPawn(Owner).Player.Console).bShowSpeech)
		return;
	
	C.bNoSmooth = False;
	DrawMonsterName(C);
	C.bNoSmooth = True;
}

simulated function DrawMonsterName(Canvas C) 
{
	
	local float Dist;
	local ScriptedPawn P;
	//local SV_ControlPointPawn CP;
	local int XPos, YPos;
	local Vector X,Y,Z, Dir;
	
	GetAxes(Owner.Rotation, X, Y, Z);
	C.Font = Font'WhiteFont';
	if (Level.bHighDetailMode)
		C.Style = ERenderStyle.STY_Translucent;
	else
		C.Style = ERenderStyle.STY_Normal;

	ShowRaderBase(C);
	ShowRadar(C);
}

simulated function ShowRaderBase(Canvas C) 
{
	
	local float RadarWidth, PulseWidth, PulseBrightness;
	
	RadarScale = Default.RadarScale * 0.5;
	RadarWidth = 0.5 * RadarScale * C.ClipX;
	PulseWidth = RadarScale * C.ClipX;
	C.DrawColor = RadarColor;
	C.Style = ERenderStyle.STY_Translucent;
	
	PulseBrightness = FMax(0,(1 - 2*RadarPulse) * 255.0);
	C.DrawColor.R = PulseBrightness;
	C.DrawColor.G = PulseBrightness;
	C.DrawColor.B = PulseBrightness;
	C.SetPos(RadarPosX*C.ClipX - 0.5*PulseWidth,RadarPosY*C.ClipY+RadarWidth-0.5*PulseWidth);
	C.DrawTile(Texture'Survival2.RadarBase.Radar', PulseWidth, PulseWidth, 0, 0, 142, 142);
	
	PulseWidth = RadarPulse * RadarScale * C.ClipX;
	C.DrawColor = RadarColor;
	C.SetPos(RadarPosX*C.ClipX - 0.5*PulseWidth,RadarPosY*C.ClipY+RadarWidth-0.5*PulseWidth);
	C.DrawTile(Texture'Survival2.RadarBase.Radar', PulseWidth, PulseWidth, 0, 0, 142, 142);
	
	C.DrawColor = WhiteColor;
	C.SetPos(RadarPosX*C.ClipX - RadarWidth,RadarPosY*C.ClipY);
	C.DrawTile(Texture'Survival2.RadarBase.RadarBorder', RadarWidth*2, RadarWidth*2, 0, 0, 142, 142);
}

simulated function ShowRadar(Canvas C) 
{
	
	local Pawn P;
	local float Dist, MaxDist, RadarWidth, PulseBrightness, Angle, DotSize, OffsetY, OffsetScale;
	local rotator Dir;
	local vector Start;
	
	LastDrawRadar = Level.TimeSeconds;
	RadarWidth = 0.5 * RadarScale * C.ClipX;
	DotSize = 24 * C.ClipX /1600;
	if (PawnOwner == None)
		Start = PlayerOwner.Location;
	else
		Start = PawnOwner.Location;
	
	MaxDist = 3000 * RadarPulse;
	//C.Style = ERenderStyle.STY_Translucent;
	OffsetY = RadarPosY + RadarWidth / C.ClipY;
	
	foreach AllActors(class'Pawn', P)
		if (P.Health > 0 && (P.IsA('ScriptedPawn') || P.IsA('Bot') || P.IsA('TournamentPlayer')))
                        {
			
			Dist = VSize(Start - P.Location);
			if (Dist < 3000) {
				if (Dist < MaxDist)
					PulseBrightness = 255 - 255 * Abs(Dist*0.00033 - RadarPulse);
				else
					PulseBrightness = 255 - 255 * Abs(Dist*0.00033 - RadarPulse - 1);
				if (P.IsA('ScriptedPawn')) 
                                {
					C.DrawColor.R = PulseBrightness;
					C.DrawColor.G = 0;
					//C.DrawColor.G = PulseBrightness;
					C.DrawColor.B = 0;
				} 
                                else if (P.IsA('Bot') || P.IsA('TournamentPlayer')) 
                                {
					C.DrawColor.R = 0;
					C.DrawColor.B = 0;
					C.DrawColor.G = PulseBrightness;
				}
				Dir = rotator(P.Location - Start);
				OffsetScale = RadarScale * Dist * 0.000167;
				Angle = ((Dir.Yaw - PlayerOwner.Rotation.Yaw) & 65535) * 6.2832 / 65536;
				C.SetPos(RadarPosX * C.ClipX + OffsetScale * C.ClipX * sin(Angle) - 0.5 * DotSize,
					OffsetY * C.ClipY - OffsetScale * C.ClipY * cos(Angle) - 0.5 * DotSize);
				C.DrawTile(Texture'Survival2.RadarBase.Dots', DotSize, DotSize, 0, 0, 16, 16);
			}
		}            
}

simulated function DrawGameSynopsis(Canvas C) 
{
	
	local float XL, YL, XN, YN, XOffset, YOffset, YNOffset;
	local int ShowFrags, In, Out, Total;//TotalSurvivors
	local Pawn P;
	local SV_ReplicationInfo ACGRI;


		
	if ((PawnOwner.PlayerReplicationInfo == None)
		|| PawnOwner.PlayerReplicationInfo.bIsSpectator) 
                {
		
		return;
	}
	
	//Cycle HUD Text Color
	//Red Color
	if ( CycleR == 0 )
		{
		CycleColorR += ColorStepR;
		if ( CycleColorR >=255 )
			{
			CycleColorR = 255;
			CycleR = 1;
			}
		}
	else
		{
		CycleColorR -= ColorStepR;
		if ( CycleColorR <= 0 )
			{
			CycleColorR = 0;
			CycleR = 0;
			}
		}
	//Green Color
	if ( CycleG == 0 )
		{
		CycleColorG += ColorStepG;
		if ( CycleColorG >=255 )
			{
			CycleColorG = 255;
			CycleG = 1;
			}
		}
	else
		{
		CycleColorG -= ColorStepG;
		if ( CycleColorG <= 0 )
			{
			CycleColorG = 0;
			CycleG = 0;
			}
		}
	//Blue Color
	if ( CycleB == 0 )
		{
		CycleColorB += ColorStepB;
		if ( CycleColorB >=255 )
			{
			CycleColorB = 255;
			CycleB = 1;
			}
		}
	else
		{
		CycleColorB -= ColorStepB;
		if ( CycleColorB <= 0 )
			{
			CycleColorB = 0;
			CycleB = 0;
			}
		}
	C.DrawColor.R = CycleColorR;
	C.DrawColor.G = CycleColorG;
	C.DrawColor.B = CycleColorB;

	//Set font, StrLength, OffSet and get frag count from player
	C.Font = MyFonts.GetSmallFont(C.ClipX);
	C.StrLen(" "$RankString, XL, YL);
	YOffset = C.ClipY - YL * 5;
	ShowFrags = PawnOwner.PlayerReplicationInfo.Score; // turn float into integer as PlayerScore is stored as float in game somehow.
	
	//Armor string
	C.SetPos(0, YOffset );
	C.DrawText("Armor: "@ShowArmor, False);

	//Health string
	C.SetPos(0, YOffset + YL );
	C.DrawText("Health: "@PawnOwner.Health, False);

	//Ammo string
	C.SetPos(0, YOffset + YL * 2 );
	C.DrawText("Ammo: "@ShowAmmo, False);

	//Total Score string
	C.SetPos(0, YOffset + YL * 3 );
	C.DrawText("Score : "@ShowFrags, False);

	//Ammo string
	C.SetPos(0, YOffset + YL * 4 );
	C.DrawText("Weapon: "@ShowWeapon, False);

	YOffset = C.ClipY - YL * 2;
	C.bCenter=True;

	C.DrawColor.R = CycleColorR;
	C.DrawColor.G = CycleColorG;
	C.DrawColor.B = CycleColorB;

	//Wave string
	C.SetPos(0, YOffset);
	C.DrawText("Wave: "$string(SV_ReplicationInfo(PlayerPawn(Owner).GameReplicationInfo).CurrentWave)$"/16", False);
	
	//Monster string
	C.SetPos(0, YOffset + YL);
	C.DrawText("Monsters: "$string(SV_ReplicationInfo(PlayerPawn(Owner).GameReplicationInfo).MonsterTotal), False);

	C.bCenter=False;
}


simulated function DrawAmmo(Canvas Canvas)
{

	//Grab variables for the HUD to display
	if ( (PawnOwner.Weapon == None) || (PawnOwner.Weapon.AmmoType == None) )
		{
        	return;
		}
	if ( PawnOwner != none )
		{
		ShowAmmo = PawnOwner.Weapon.AmmoType.AmmoAmount;
		ShowWeapon = PawnOwner.Weapon.ItemName;
		}
}

simulated function DrawWeapons(Canvas Canvas)
{
	local int JustToEmptyTheDrawWeapons; //emptied the DrawWeapons function to remove the weapons from HUD by force.
}

simulated function DrawStatus(Canvas C) 
{
	
	//Super.DrawStatus(C);
	
	local float StatScale, ChestAmount, ThighAmount, H1, H2, X, Y, DamageTime;
	local int ArmorAmount,CurAbs,i;
	local inventory Inv,BestArmor;
	local bool bChestArmor, bShieldbelt, bThighArmor, bJumpBoots, bHasDoll;
	local Bot BotOwner;
	local TournamentPlayer TPOwner;
	local texture Doll, DollBelt;

	ArmorAmount = 0;
	CurAbs = 0;
	i = 0;
	BestArmor=None;
	for(Inv=PawnOwner.Inventory; Inv!=None; Inv=Inv.Inventory) 
        {
		
		if (Inv.bIsAnArmor) 
                {
			if (Inv.IsA('SV_Armor'))
                        {
				bShieldbelt = true;
			} else if (Inv.IsA('UT_Shieldbelt')) 
                        {
				bShieldbelt = true;
			} else if (Inv.IsA('Thighpads')) 
                        {
				ThighAmount += Inv.Charge;
				bThighArmor = true;
			} else {
				bChestArmor = true;
				ChestAmount += Inv.Charge;
			}
			ArmorAmount += Inv.Charge;
		} else if (Inv.IsA('UT_JumpBoots')) 
                {
			bJumpBoots = true;
		} else {
			i++;
			if (i > 100)
				break; // can occasionally get temporary loops in netplay
		}
	}
	
	if (!bHideStatus) 
        {
		TPOwner = TournamentPlayer(PawnOwner);
		if (C.ClipX < 400) 
                {
			bHasDoll = false;
		} 
                else if ( TPOwner != None)
                {
			Doll = TPOwner.StatusDoll;
			DollBelt = TPOwner.StatusBelt;
			bHasDoll = true;
		} 
                else 
                {
			BotOwner = Bot(PawnOwner);
			if (BotOwner != None) 
                        {
				Doll = BotOwner.StatusDoll;
				DollBelt = BotOwner.StatusBelt;
				bHasDoll = true;
			}
		}
		if (bHasDoll) 
                {
			C.Style = ERenderStyle.STY_Translucent;
			StatScale = Scale * StatusScale;
			X = C.ClipX - 128 * StatScale;
			C.SetPos(X, 0);
			if (PawnOwner.DamageScaling > 2.0)
				C.DrawColor = PurpleColor;
			else
				C.DrawColor = HUDColor;
			
			C.DrawColor = HUDColor;
			
			C.Style = Style;
		}
	}
	C.DrawColor = HUDColor;

	ShowArmor = ArmorAmount;
}

simulated function DrawFragCount(Canvas Canvas) 
{
	
	local float Whiten;
	local int X,Y;
	
	if (PawnOwner.PlayerReplicationInfo == None )
		return;
}

simulated function Tick(float DT) 
{
	local Pawn P;
	
	Super.Tick(DT);
	
	RadarPulse = RadarPulse + 0.5 * DT;
	if (RadarPulse >= 1) 
        {
		RadarPulse = RadarPulse - 1;
	}

	if ( UpDown == 0 )
		{
		Fade += 5;
		if ( Fade >= 255 )
			{
			Fade = 255;
			WaitTime++;
			if ( WaitTime >= 275 )
				{
				UpDown = 1;
				WaitTime = 0;
				}
			}
		}
	else
		{
		Fade -= 5;
		if ( Fade <= 20 )
			{
			Fade = 20;
			StatCount++;
			UpDown = 0;
			}
		}
}

simulated function DrawMOTD(Canvas Canvas)
{
	local GameReplicationInfo GRI;
	local float XL, YL;
	local float InitialY;

	GRI = PlayerPawn(Owner).GameReplicationInfo;
	if ( (GRI == None) || (GRI.GameName == "Game") || (MOTDFadeOutTime <= 0) ) 
		return;

	Canvas.Font = MyFonts.GetSmallFont( Canvas.ClipX );
	Canvas.Style = Style;
	Canvas.bCenter = true;
	Canvas.DrawColor = UnitColor * MOTDFadeOutTime * 0.5;
	InitialY = 64*Scale;
	Canvas.SetPos(0.0, InitialY);
	Canvas.StrLen("TEST", XL, YL);
	if ( Level.NetMode != NM_Standalone )
	{
		Canvas.DrawText(GRI.ServerName);
		if ( Canvas.ClipY >= 300 )
		{
			Canvas.SetPos(0.0, InitialY + 6*YL);
			Canvas.DrawText(GRI.MOTDLine1, true);
			Canvas.SetPos(0.0, InitialY + 7*YL);
			Canvas.DrawText(GRI.MOTDLine2, true);
			Canvas.SetPos(0.0, InitialY + 8*YL);
			Canvas.DrawText(GRI.MOTDLine3, true);
			Canvas.SetPos(0.0, InitialY + 9*YL);
			Canvas.DrawText(GRI.MOTDLine4, true);
		}
	}
	Canvas.DrawColor = UnitColor * MOTDFadeOutTime * 0.6;
	Canvas.SetPos(0.0, InitialY + YL);
	Canvas.DrawText(GRI.GameName, true);
	Canvas.SetPos(0.0, InitialY + 2*YL);
	Canvas.DrawText(MapTitleString2@Level.Title, true);
	if ( Canvas.ClipY >= 300 )
	{
		Canvas.SetPos(0.0, InitialY + 3*YL);
		Canvas.DrawText(AuthorString2@Level.Author, true);
		if (Level.IdealPlayerCount != "")
		{
			Canvas.SetPos(0.0, InitialY + 4*YL);
			Canvas.DrawText(PlayerCountString$Level.IdealPlayerCount, true);
		}
	}
	Canvas.bCenter = false;
}


defaultproperties
{
    LightCyanColor=(R=128,G=255,B=255,A=0)
    RadarColor=(R=126,G=126,B=126)
    HUDelementColor=(R=20,G=20,B=20)
    RadarScale=0.20
    RadarPosX=0.05
    RadarPosY=0.70
    ColorStepR=4
    ColorStepG=3
    ColorStepB=2
    bShowStats=True
    P1=Gopostal
    P2=TheDane
    P3=GopostalsWifey
    P4=TheDanesWifey
    P5=MickeyMouse
    P6=Goofy
    P7=DonaldDuck
    P8=Cinderella
    P9=LittleMermaid
    P10=SantaClaus
    S1=1000
    S2=900
    S3=800
    S4=700
    S5=600
    S6=500
    S7=400
    S8=300
    S9=200
    S10=100
    G1=1
    G2=2
    G3=3
    G4=4
    G5=5
    G6=6
    G7=7
    G8=8
    G9=9
    G10=10
}
