// SV_Invincibility

class SV_Invincible extends UT_Invisibility config(Survival2);

#exec obj load file=..\Textures\Belt_fx.utx package=Belt_fx
#exec TEXTURE IMPORT NAME=SV_Invincible FILE=Textures\SV_Invincible.bmp
#exec mesh import mesh=SV_Invincible anivfile=Models\SV_Invincible_a.3d datafile=Models\SV_Invincible_d.3d x=0 y=0 z=0 mlod=0
#exec mesh origin mesh=SV_Invincible x=0 y=0 z=0
#exec mesh sequence mesh=SV_Invincible seq=All startframe=0 numframes=1
#exec meshmap new meshmap=SV_Invincible mesh=SV_Invincible
#exec meshmap scale meshmap=SV_Invincible x=0.12500 y=0.12500 z=0.25000

var int PHealth, PArmor;
var int ShowCharge;
var config int bRespawnTime;

state Activated
{
	function endstate()
		{
		local Inventory S;
		local PlayerPawn P;
	
		P = PlayerPawn(Owner);
		P.ReducedDamageType = '';

		bActive = false;
		
		PlaySound(DeActivateSound);

		Owner.SetDefaultDisplayProperties();
		S = Pawn(Owner).FindInventoryType(class'UT_ShieldBelt');
		if ( (S != None) && (UT_Shieldbelt(S).MyEffect != None) )
			{
			UT_Shieldbelt(S).MyEffect.bHidden = false;
			}
		PHealth = 0;
		PArmor = 0;
		
		}

	function Activate()
		{
		bActive = true;
		SetOwnerDisplay();
		}

	function SetOwnerDisplay()
		{
		if ( !bActive )
			{
			return;
			}

		Owner.SetDisplayProperties(ERenderStyle.STY_Translucent,FireTexture'UnrealShare.Belt_fx.ShieldBelt.RedShield',true,true);
		}

	function ChangedWeapon()
		{
		if ( !bActive )
			{
			return;
			}
		if( Inventory != None )
			{
			Inventory.ChangedWeapon();
			}

		//Now put on some color yeah
		if ( Pawn(Owner).Weapon != None )
			{
			Pawn(Owner).Weapon.SetDisplayProperties(ERenderStyle.STY_Translucent,FireTexture'UnrealShare.Belt_fx.ShieldBelt.RedShield',true,true);
			}
		}

	function Timer()
	{
		Charge -= 1;
		Pawn(Owner).Visibility = 10;
		Owner.AmbientGlow = 250; 
		Owner.LightEffect=LE_Rotor;//NonIncidence
		Owner.LightBrightness=64;
		Owner.LightHue=255;
		Owner.LightRadius=32;
		Owner.LightSaturation=127;
		Owner.LightType=LT_Steady;
		Pawn(Owner).DamageScaling = 3.0;
		ShowCharge = Charge;
		if (Charge<-0)
			{
			Owner.AmbientGlow = Owner.Default.AmbientGlow;
			Owner.LightType = LT_None;
			Pawn(Owner).DamageScaling = 1.0;
			UsedUp();
			}
		if ( Charge < 12 && Charge > 0 )
			{
			Owner.PlaySound(Sound'BotPack.ChatSound.NewBeep');
			}
	}

	function BeginState()
	{
		local Inventory S;

		bActive = true;
		PlaySound(ActivateSound,,4.0);

		Owner.SetDisplayProperties(ERenderStyle.STY_Translucent,FireTexture'UnrealShare.Belt_fx.ShieldBelt.RedShield',false,true);
		SetTimer(0.5,True);
		S = Pawn(Owner).FindInventoryType(class'UT_ShieldBelt');
		if ( (S != None) && (UT_Shieldbelt(S).MyEffect != None) )
			{
			UT_Shieldbelt(S).MyEffect.bHidden = true;
			}
	}

	simulated function Tick(float DT) 
	{
	local PlayerPawn P;
	
	P = PlayerPawn(Owner);

	Super.Tick(DT);

	P.ReducedDamageType = 'All';
	}
}

state DeActivated
{
Begin:
}

State Sleeping
{
    ignores Touch;

    function BeginState()
    {
        BecomePickup();
        bHidden = true;
    }
    function EndState()
    {
        local int i;

        bSleepTouch = false;
        for ( i=0; i<4; i++ )
            if ( (Touching[i] != None) && Touching[i].IsA('Pawn') )
                bSleepTouch = true;
    }           
Begin:
    Sleep( bReSpawnTime );
    PlaySound( RespawnSound );  
    Sleep( Level.Game.PlaySpawnEffect(self) );
    GoToState( 'Pickup' );
}

defaultproperties
{

     ExpireMessage="You are no longer invincible."
     PickupMessage="You are now invincible."
     ItemName="Invincibility"
     bRespawnTime=1.0000
     PickupViewMesh=Mesh'Survival2.SV_Invincible'
     Charge=150
     PickupSound=Sound'UnrealShare.Pickups.GenPickSnd'
     ActivateSound=Sound'BotPack.Pickups.UTSuperHeal'
     DeActivateSound=Sound'UnrealI.Generic.Teleport1'
     MultiSkins(0)=Texture'Belt_fx.ShieldBelt.RedShield'
     MultiSkins(1)=Texture'Survival2.SV_Invincible'
     Mesh=Mesh'Survival2.SV_Invincible'
     CollisionRadius=32.000000
     CollisionHeight=32.000000
     bCollideWhenPlacing=True
     bRotatingPickup=True
     RotationRate=(Roll=12500)
     RotationRate=(Pitch=12250)
     RotationRate=(Yaw=12000)
}
