class SV_MapStatsNotify expands SpawnNotify;

// top 10 config vars:
var string Map1, Map2, Map3, Map4, Map5, Map6, Map7, Map8, Map9, Map10;
var int V1, V2, V3, V4, V5, V6, V7, V8, V9, V10;
var int DrawTime;
var bool bShowUntitled;
var color MapStatsColor;

replication
{
	reliable if(Role==ROLE_Authority && bNetInitial)
		Map1, Map2, Map3, Map4, Map5, Map6, Map7, Map8, Map9, Map10,
		V1, V2, V3, V4, V5, V6, V7, V8, V9, V10,
		DrawTime, bShowUntitled, MapStatsColor;
}

simulated function PreBeginPlay()
{
	bAlwaysRelevant = true;
	if(ROLE == ROLE_Authority)
	{
		SetTimer(1.0, true);
	}
}

simulated function PostNetBeginPlay()
{
	local ChallengeHUD PlayerHUD;

	foreach AllActors(Class'ChallengeHUD',PlayerHUD)
	{
		SpawnNotification(PlayerHUD);
	}
}

simulated event Actor SpawnNotification(actor Actor)
{
	local sv_MapStatsHUDMutator tmpHUD;
	local int i;

	if (Actor != None)
	{
		if (Actor.IsA('HUD') && (HUD(Actor).HUDMutator == None || !HUD(Actor).HUDMutator.IsA('SV_MapStatsHUDMutator')))
		{
			tmpHUD = spawn(class'SV_MapStatsHUDMutator', Actor);
			if (tmpHUD != None)
				{
				tmpHUD.Player = PlayerPawn(Actor.Owner);
				// Transfer statistic vars
				tmpHUD.Map1 = Map1;
				tmpHUD.Map2 = Map2;
				tmpHUD.Map3 = Map3;
				tmpHUD.Map4 = Map4;
				tmpHUD.Map5 = Map5;
				tmpHUD.Map6 = Map6;
				tmpHUD.Map7 = Map7;
				tmpHUD.Map8 = Map8;
				tmpHUD.Map9 = Map9;
				tmpHUD.Map10 = Map10;
				tmpHUD.V1 = V1;
				tmpHUD.V2 = V2;
				tmpHUD.V3 = V3;
				tmpHUD.V4 = V4;
				tmpHUD.V5 = V5;
				tmpHUD.V6 = V6;
				tmpHUD.V7 = V7;
				tmpHUD.V8 = V8;
				tmpHUD.V9 = V9;
				tmpHUD.V10 = V10;
				tmpHUD.DrawTime = DrawTime;
				tmpHUD.bShowUntitled = bShowUntitled;
				tmpHUD.MapStatsColor = MapStatsColor;

				if (HUD(Actor).HUDMutator == None)
					HUD(Actor).HUDMutator = tmpHUD;
				else
				{
					tmpHUD.NextHUDMutator = HUD(Actor).HUDMutator;
					HUD(Actor).HUDMutator = tmpHUD;
				}
			}
		}
	}

	return Actor;
}

defaultproperties
{
	bHidden=True
}
