// SV_OneUp

class SV_OneUp extends UT_Invisibility config(Survival2);

#exec obj load file=..\Textures\Belt_fx.utx package=Belt_fx
#exec TEXTURE IMPORT NAME=1upA FILE=Textures\1upA.bmp

#exec mesh import mesh=oneupA anivfile=Models\oneupA_a.3d datafile=Models\oneupA_d.3d x=0 y=0 z=0 mlod=0
#exec mesh origin mesh=oneupA x=0 y=0 z=0
#exec mesh sequence mesh=oneupA seq=All startframe=0 numframes=1

#exec meshmap new meshmap=oneupA mesh=oneupA
#exec meshmap scale meshmap=oneupA x=0.06250 y=0.06250 z=0.12500

var config int bRespawnTime;

state Activated
{
    function endstate()
    {
        local Inventory S;

        bActive = false;        
        PlaySound(DeActivateSound);

        Owner.SetDefaultDisplayProperties();
        S = Pawn(Owner).FindInventoryType(class'UT_ShieldBelt');
        if ( (S != None) && (UT_Shieldbelt(S).MyEffect != None) )
            UT_Shieldbelt(S).MyEffect.bHidden = false;
    }

    function Activate()
    {
        //local Pawn P;
        bActive = true;
        //P.PlayerReplicationInfo.Deaths +=1;
	//Pawn(Owner).PlayerReplicationInfo.Deaths +=1;
        SetOwnerDisplay();
    }


    function SetOwnerDisplay()
    {
    }
    function ChangedWeapon()
    {
    }

    function BeginState()
    {
        local Inventory S;

        bActive = true;
        PlaySound(ActivateSound,,4.0);
    }

    simulated function Tick(float DT)
	{
	local PlayerPawn P;
	local bool bRunOnce;

	P = PlayerPawn(Owner);

	Super.Tick(DT);
	if ( !bRunOnce )
		{
                P.PlayerReplicationInfo.Deaths = (P.PlayerReplicationInfo.Deaths) + 1;
		GoToState('DeActivated');
                bRunOnce = True;
		}
	}
}

state DeActivated
{
Begin:
}

State Sleeping
{
    ignores Touch;

    function BeginState()
    {
        BecomePickup();
        bHidden = true;
    }
    function EndState()
    {
        local int i;

        bSleepTouch = false;
        for ( i=0; i<4; i++ )
            if ( (Touching[i] != None) && Touching[i].IsA('Pawn') )
                bSleepTouch = true;
    }           
Begin:
    Sleep( bReSpawnTime );
    PlaySound( RespawnSound );  
    Sleep( Level.Game.PlaySpawnEffect(self) );
    GoToState( 'Pickup' );
}

defaultproperties
{
     PickupMessage="You got a free life this round."
     ItemName="OneUp"
     bRespawnTime=15.000000
     PickupViewMesh=Mesh'Survival2.SV_Invincible'
     PickupSound=Sound'UnrealShare.Pickups.GenPickSnd'
     ActivateSound=Sound'BotPack.Pickups.UTSuperHeal'
     MultiSkins(0)=Texture'Belt_fx.ShieldBelt.N_Shield'
     MultiSkins(1)=Texture'Survival2.1upA'
     Mesh=Mesh'oneupA'
     CollisionRadius=32.000000
     CollisionHeight=32.000000
     bCollideWhenPlacing=True
     bRotatingPickup=True
     RotationRate=(Roll=12500)
     RotationRate=(Pitch=12250)
     RotationRate=(Yaw=12000)
}
