class SV_ScoreBoard extends TournamentScoreBoard;

#exec Texture Import File=Textures\SurvivalLogo.bmp Name=SurvivalLogo Maps=Off Flags=2

function DrawCategoryHeaders(Canvas Canvas) 
{
	
	local float Offset, XL, YL;
	
	Offset = 156;
	Canvas.DrawColor = BlueColor;
	
	Canvas.StrLen("Player", XL, YL);
	Canvas.SetPos((Canvas.ClipX / 8)* 0.8, Offset);
	Canvas.DrawText("Player");
	
	Canvas.StrLen("Score", XL, YL);
	Canvas.SetPos((Canvas.ClipX / 8)* 5 + XL/2 - XL, Offset);
	Canvas.DrawText("Score");
	
	Canvas.StrLen("Lives", XL, YL);
	Canvas.SetPos((Canvas.ClipX / 8)* 6 + XL/2 - XL, Offset);
	Canvas.DrawText("Lives");
}

function DrawNameAndPing
(
	Canvas Canvas,
	PlayerReplicationInfo PRI,
	float XOffset,
	float YOffset,
	bool bCompressed
) 
{
	local float XL, YL, XL2, YL2, XL3, YL3;
	local Font CanvasFont;
	local int Time;
	local PlayerPawn PlayerOwner;
	
	PlayerOwner = PlayerPawn(Owner);
	
	// Draw Name
	if (PRI.bAdmin)
		Canvas.DrawColor = WhiteColor;
	else if (PRI.PlayerName == Pawn(Owner).PlayerReplicationInfo.PlayerName)
		Canvas.DrawColor = GoldColor;
	else 
		Canvas.DrawColor = SilverColor;
	Canvas.SetPos((Canvas.ClipX / 8) * 0.8, YOffset);
	Canvas.DrawText(PRI.PlayerName, False);
	
	Canvas.StrLen("000000", XL, YL);
	
	// Draw Score
	if (PRI.Score < 1)
		Canvas.DrawColor = LightCyanColor;
	else
		Canvas.DrawColor = GoldColor;
	
	Canvas.StrLen(int(PRI.Score), XL2, YL);
	Canvas.SetPos((Canvas.ClipX / 8) * 5 + XL/2 - XL2, YOffset);
	Canvas.DrawText(int(PRI.Score), false);
	
	if (int(PRI.Deaths) < 1) 
        {
		Canvas.StrLen("OUT", XL2, YL);
		Canvas.SetPos((Canvas.ClipX / 8) * 6 + XL/3.1 - XL2, YOffset);
		Canvas.DrawText("OUT", False);
	} 
        else 
        {
		Canvas.StrLen(int(PRI.Deaths), XL2, YL);
		Canvas.SetPos((Canvas.ClipX / 8) * 6 + XL/3.1 - XL2, YOffset);
		Canvas.DrawText(int(PRI.Deaths), false);
	}
	
	/*
	if (Level.NetMode != NM_Standalone) {
		// Draw Ping
		Canvas.DrawColor = LightCyanColor;
		Canvas.StrLen(PRI.Ping, XL2, YL);
		Canvas.SetPos((Canvas.ClipX / 8) * 7 + XL/2 - XL2, YOffset);
		Canvas.DrawText(PRI.Ping, false);
	}*/
	if ((Canvas.ClipX > 512) && (Level.NetMode != NM_Standalone)) 
        {
		
		Canvas.DrawColor = LightCyanColor;
		CanvasFont = Canvas.Font;
		Canvas.Font = MyFonts.GetSmallestFont(Canvas.ClipX);
		
		// Draw Time
		Time = Max(1, (Level.TimeSeconds + PlayerOwner.PlayerReplicationInfo.StartTime - PRI.StartTime) / 60);
		Canvas.TextSize( TimeString$": 999", XL3, YL3 );
		Canvas.SetPos( Canvas.ClipX * 0.75 + XL, YOffset );
		Canvas.DrawText( TimeString$":"@Time, false );
		
		// Draw FPH
		Canvas.TextSize( FPHString$": 999", XL2, YL2 );
		Canvas.SetPos( Canvas.ClipX * 0.75 + XL, YOffset + 0.5 * YL );
		Canvas.DrawText( FPHString$": "@int(60 * PRI.Score/Time), false );
		
		XL3 = FMax(XL3, XL2);
		// Draw Ping
		Canvas.SetPos( Canvas.ClipX * 0.75 + XL + XL3 + 16, YOffset );
		Canvas.DrawText( PingString$":"@PRI.Ping, false );
		
		// Draw Packetloss
		Canvas.SetPos( Canvas.ClipX * 0.75 + XL + XL3 + 16, YOffset + 0.5 * YL );
		Canvas.DrawText( LossString$":"@PRI.PacketLoss$"%", false );
		
		Canvas.Font = CanvasFont;
	}
}

function DrawVictoryConditions(Canvas Canvas)
{
	local TournamentGameReplicationInfo TGRI;
	local float XL, YL;
	
	TGRI = TournamentGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
	if ( TGRI == None )
		return;
	
	Canvas.SetPos(Canvas.ClipX * 0.5 - 128, 4 );
	Canvas.Style = ERenderStyle.STY_Translucent;
	Canvas.DrawIcon(Texture'Survival2.SurvivalLogo', 1);
	Canvas.Style = ERenderStyle.STY_Normal;

	Canvas.SetPos(Canvas.ClipX * 0.5 + 125, 75 ); // 0
	Canvas.DrawColor = GreenColor;
	Canvas.DrawText("Wave: "@SV_ReplicationInfo(TGRI).CurrentWave$"/16");
	Canvas.DrawColor = WhiteColor;
}


defaultproperties
{


}
