

class SV_SlithProj extends UT_BioGel;

auto state Flying 
{
	
	function ProcessTouch (Actor Other, vector HitLocation) 
        {
		
		if (Pawn(Other)!=Instigator || bOnGround)
			Global.Timer();
	}
	
	simulated function HitWall(vector HitNormal, actor Wall) 
        {
		
		SetPhysics(PHYS_None);
		MakeNoise(0.3);
		bOnGround = True;
		PlaySound(ImpactSound);
		SetWall(HitNormal, Wall);
		PlayAnim('Hit');
		GoToState('OnSurface');
	}
	
	simulated function ZoneChange(Zoneinfo NewZone) 
        {
		
		local waterring w;
		
		if (!NewZone.bWaterZone)
			Return;
		
		if (!bOnGround) 
                {
			w = Spawn(class'WaterRing', , , , rot(16384, 0, 0));
			w.DrawScale = 0.1;
		}
		
		bOnGround = True;
		Velocity=0.1*Velocity;
	}
	
	function Timer() 
        {
		
		GotoState('Exploding');	
	}
	
	function BeginState() 
        {
		
		if (Role == ROLE_Authority) 
                {
			Velocity = Vector(Rotation) * Speed;
		}

		if (Level.NetMode != NM_DedicatedServer)
			RandSpin(100000);
		
		LoopAnim('Flying',0.4);
		bOnGround=False;
		PlaySound(SpawnSound);
	}
}

defaultproperties
{
    speed=750.00
    Damage=40.00
    SpawnSound=Sound'UnrealShare.Slith.SliSpawn'
    ImpactSound=Sound'UnrealShare.Slith.SliImpact'
    Physics=6
}
