class SV_SpawnProtection extends SV_Invincible;

var int PHealth, PArmor;
var int ShowCharge;

state Activated
{
	function endstate()
		{
		local Inventory S;
		local PlayerPawn P;
	
		P = PlayerPawn(Owner);
		P.ReducedDamageType = '';

		bActive = false;
		
		PlaySound(DeActivateSound);

		Owner.SetDefaultDisplayProperties();
		S = Pawn(Owner).FindInventoryType(class'UT_ShieldBelt');
		if ( (S != None) && (UT_Shieldbelt(S).MyEffect != None) )
			{
			UT_Shieldbelt(S).MyEffect.bHidden = false;
			}
		PHealth = 0;
		PArmor = 0;
		
		}

	function Activate()
		{
		bActive = true;
		SetOwnerDisplay();
		}

	function SetOwnerDisplay()
		{
		if ( !bActive )
			{
			return;
			}

		Owner.SetDisplayProperties(ERenderStyle.STY_Translucent,FireTexture'UnrealShare.Belt_fx.ShieldBelt.BlueShield',true,true);
		}

	function ChangedWeapon()
		{
		if ( !bActive )
			{
			return;
			}
		if( Inventory != None )
			{
			Inventory.ChangedWeapon();
			}

		//Now put on some color yeah
		if ( Pawn(Owner).Weapon != None )
			{
			Pawn(Owner).Weapon.SetDisplayProperties(ERenderStyle.STY_Translucent,FireTexture'UnrealShare.Belt_fx.ShieldBelt.BlueShield',true,true);
			}
		}

	function Timer()
	{
		Charge -= 1;
		Pawn(Owner).Visibility = 10;
		Owner.AmbientGlow = 250; 
		Pawn(Owner).DamageScaling = 3.0;
		ShowCharge = Charge;
		if (Charge<-0)
			{
			Owner.AmbientGlow = Owner.Default.AmbientGlow;
			Owner.LightType = LT_None;
			Pawn(Owner).DamageScaling = 1.0;
			UsedUp();
			}
		if ( Charge > 0 )
			{
			Owner.PlaySound(Sound'BotPack.ChatSound.NewBeep');
			}
	}

	function BeginState()
	{
		local Inventory S;

		bActive = true;
		PlaySound(ActivateSound,,4.0);

		Owner.SetDisplayProperties(ERenderStyle.STY_Translucent,FireTexture'UnrealShare.Belt_fx.ShieldBelt.BlueShield',false,true);
		SetTimer(0.5,True);
		S = Pawn(Owner).FindInventoryType(class'UT_ShieldBelt');
		if ( (S != None) && (UT_Shieldbelt(S).MyEffect != None) )
			{
			UT_Shieldbelt(S).MyEffect.bHidden = true;
			}
	}

	simulated function Tick(float DT) 
	{
	local PlayerPawn P;
	
	P = PlayerPawn(Owner);

	Super.Tick(DT);

	P.ReducedDamageType = 'All';
	}
}

state DeActivated
{
Begin:
}

defaultproperties
{

     ExpireMessage="You are no longer SpawnProtected."
     PickupMessage="You are now SpawnProtected."
     ItemName="Invincibility"
     RespawnTime=300.000000
     PickupViewMesh=Mesh'Survival2.SV_Invincible'
     Charge=25
     PickupSound=Sound'UnrealShare.Pickups.GenPickSnd'
     ActivateSound=Sound'BotPack.ChatSound.NewBeep'
     DeActivateSound=Sound'UnrealI.Generic.Teleport1'
     MultiSkins(0)=Texture'Belt_fx.ShieldBelt.RedShield'
     MultiSkins(1)=Texture'Survival2.SV_Invincible'
     Mesh=Mesh'Survival2.SV_Invincible'
     CollisionRadius=32.000000
     CollisionHeight=32.000000
     bCollideWhenPlacing=True
     bRotatingPickup=True
     RotationRate=(Roll=12500)
     RotationRate=(Pitch=12250)
     RotationRate=(Yaw=12000)
}
