

#exec Audio Import File="Sounds\killing_spree.wav" Name="killing_spree"
#exec Audio Import File="Sounds\rampage.wav" Name="rampage"
#exec Audio Import File="Sounds\dominating.wav" Name="dominating" 
#exec Audio Import File="Sounds\unstoppable.wav" Name="unstoppable" 
#exec Audio Import File="Sounds\godlike.wav" Name="godlike" 
#exec Audio Import File="Sounds\WhickedSick.wav" Name="WhickedSick"

class SV_SpreeMessage extends KillingSpreeMessage;

static function string GetString(
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
) {
	if (RelatedPRI_2 == None) {
		if (RelatedPRI_1 == None)
			return "";

		if (RelatedPRI_1.PlayerName != "")
			return RelatedPRI_1.PlayerName@Default.SpreeNote[Switch];
	} else {
		return RelatedPRI_2.PlayerName$Default.EndSpreeNote$Switch@"!!";
	}
	return "";
}

static simulated function ClientReceive( 
	PlayerPawn P,
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
) {
	Super(CriticalEventLowPlus).ClientReceive(P, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
	
	if (RelatedPRI_2 != None)
		return;
	
	if (RelatedPRI_1 != P.PlayerReplicationInfo) {
		P.PlaySound(sound'SpreeSound', , 4.0);
		return;
	}
	P.ClientPlaySound(Default.SpreeSound[Switch], , true);
}

defaultproperties
{
    EndSpreeNote=" has died. Total killed monsters this life was "
    spreenote(0)="is on a killing spree with 15 kills!"
    spreenote(1)="is on a rampage with 40 kills!"
    spreenote(2)="is dominating with 75 kills!"
    spreenote(3)="is unstoppable with 120 kills!"
    spreenote(4)="is GODLIKE with 175 kills!"
    spreenote(5)="**is W1CKED S1CK with 240 KILLS!!**"
    SpreeSound(0)=Sound'killing_spree'
    SpreeSound(1)=Sound'rampage'
    SpreeSound(2)=Sound'dominating'
    SpreeSound(3)=Sound'unstoppable'
    SpreeSound(4)=Sound'godlike'
    SpreeSound(5)=Sound'WhickedSick'
}
