class SV_StatsMutator expands Mutator config(SV_StatDB);

//Server admin variables:
var config bool bPurgeInactivePlayers;
var config int InactiveDays;

// top 10 config vars:
var config string TopPlayer1,TopPlayer2,TopPlayer3,TopPlayer4,TopPlayer5,TopPlayer6,TopPlayer7,TopPlayer8,TopPlayer9,TopPlayer10;
var config int TopFrags1,TopFrags2,TopFrags3,TopFrags4,TopFrags5,TopFrags6,TopFrags7,TopFrags8,TopFrags9,TopFrags10;
var config int TopGames1,TopGames2,TopGames3,TopGames4,TopGames5,TopGames6,TopGames7,TopGames8,TopGames9,TopGames10;

// database config vars:
var config int CurrentDay;
var config string SPlayer[10000];
var config float SFrags[10000];
var config float SGames[10000];
var config int SDays[10000];

// temp statistic vars, these will be xfered when game end.
var string TempPlayer[100];
var int TempFrags[100];
var bool bResetTempVars, bRunOnce;

function PreBeginPlay()
{
	local SV_StatsNotify s;
	local int i, ii;
	
	//Send top 10 players to the Notify class.
	s = spawn(class'SV_StatsNotify');
	s.TopPlayer1 = TopPlayer1;
	s.TopFrags1 = TopFrags1;
	s.TopGames1 = TopGames1;
	s.TopPlayer2 = TopPlayer2;
	s.TopFrags2 = TopFrags2;
	s.TopGames2 = TopGames2;
	s.TopPlayer3 = TopPlayer3;
	s.TopFrags3 = TopFrags3;
	s.TopGames3 = TopGames3;
	s.TopPlayer4 = TopPlayer4;
	s.TopFrags4 = TopFrags4;
	s.TopGames4 = TopGames4;
	s.TopPlayer5 = TopPlayer5;
	s.TopFrags5 = TopFrags5;
	s.TopGames5 = TopGames5;
	s.TopPlayer6 = TopPlayer6;
	s.TopFrags6 = TopFrags6;
	s.TopGames6 = TopGames6;
	s.TopPlayer7 = TopPlayer7;
	s.TopFrags7 = TopFrags7;
	s.TopGames7 = TopGames7;
	s.TopPlayer8 = TopPlayer8;
	s.TopFrags8 = TopFrags8;
	s.TopGames8 = TopGames8;
	s.TopPlayer9 = TopPlayer9;
	s.TopFrags9 = TopFrags9;
	s.TopGames9 = TopGames9;
	s.TopPlayer10 = TopPlayer10;
	s.TopFrags10 = TopFrags10;
	s.TopGames10 = TopGames10;

	//Purge inactive players, inactive days is defined in the ini file
	if ( bPurgeInactivePlayers )
		{
		log("The current day of the month is: "@Level.Day);
		if ( Level.Day != CurrentDay )
			{
			CurrentDay = Level.Day;
			for ( ii=0; ii<10000; ii++ )
				{
				if ( SPlayer[ii] != "" )
					{
					SDays[ii]++;
					}
				if ( SDays[ii] >= InactiveDays )
					{
					SPlayer[ii] = "";
					SFrags[ii] = 0;
					SGames[ii] = 0;
					SDays[ii] = 0;
					}
				}
			}
		SaveConfig();
		} 
	//Reset temp variables
	if ( !bResetTempVars )
		{
		for ( i=0; i<100; i++ )
			{
			TempPlayer[i] = "";
			TempFrags[i] = 0;
			}
		bResetTempVars = True;
		log("Survival Statistics - The mutator is active and is now gathering runtime stats on the players.");
		}
}

function ScoreKill(Pawn Killer, Pawn Other)
{
	GatherStats();
	
}

function GatherStats()
{

	local PlayerPawn P;
	local int i;

	ForEach AllActors(class'PlayerPawn', P )
		{
		for ( i=0; i<100; i++ )
			{
			if (( P.PlayerReplicationInfo.PlayerName == TempPlayer[i] ) || ( TempPlayer[i] == "" ))
				{
				TempPlayer[i] = P.PlayerReplicationInfo.PlayerName;
				TempFrags[i] = P.PlayerReplicationInfo.Score;
				i = 200;
				}
			}
		}
}

function SendStatsToDB()
{
local PlayerPawn P;
local int i,ii,a;


if ( !bRunOnce )
	{
	for ( i=0; i<100; i++ )
			{
			if ( TempPlayer[i] != "" )
				{
				for ( ii=0; ii<10000; ii++ )
					{
					if (( TempPlayer[i] == SPlayer[ii] ) || ( SPlayer[ii] == "" ))
						{
						SPlayer[ii] = TempPlayer[i];
						SFrags[ii] = SFrags[ii] + TempFrags[i];
						SGames[ii] += 1;
						SDays[ii] = 0;
						//log("Temp vars has been transfered for player :"$TempPlayer[i]);
						ii = 20000;
						}
					}
				}
			}
		
	// Find top 10 players and load the vars to the Info Class
	// find #1
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if ( SFrags[a] >= TopFrags1 )
				{
				TopPlayer1 = SPlayer[a];
				TopFrags1 = SFrags[a];
				TopGames1 = SGames[a];
				}
			}
		}
	// find #2
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if (( SFrags[a] >= TopFrags2 ) && ( SPlayer[a] != TopPlayer1 ))
				{
				TopPlayer2 = SPlayer[a];
				TopFrags2 = SFrags[a];
				TopGames2 = SGames[a];
				}
			}
		}
	// find #3
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if (( SFrags[a] >= TopFrags3 ) && ( SPlayer[a] != TopPlayer1 ) && ( SPlayer[a] != TopPlayer2 ))
				{
				TopPlayer3 = SPlayer[a];
				TopFrags3 = SFrags[a];
				TopGames3 = SGames[a];
				}
			}
		}
	// find #4
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if (( SFrags[a] >= TopFrags4 ) && ( SPlayer[a] != TopPlayer1 ) && ( SPlayer[a] != TopPlayer2 ) && ( SPlayer[a] != TopPlayer3 ))
				{
				TopPlayer4 = SPlayer[a];
				TopFrags4 = SFrags[a];
				TopGames4 = SGames[a];
				}
			}
		}
	// find #5
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if (( SFrags[a] >= TopFrags5 ) && ( SPlayer[a] != TopPlayer1 ) && ( SPlayer[a] != TopPlayer2 ) && ( SPlayer[a] != TopPlayer3 ) && ( SPlayer[a] != TopPlayer4 ))
				{
				TopPlayer5 = SPlayer[a];
				TopFrags5 = SFrags[a];
				TopGames5 = SGames[a];
				}
			}
		}
	// find #6
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if (( SFrags[a] >= TopFrags6 ) && ( SPlayer[a] != TopPlayer1 ) && ( SPlayer[a] != TopPlayer2 ) && ( SPlayer[a] != TopPlayer3 ) && ( SPlayer[a] != TopPlayer4 ) && ( SPlayer[a] != TopPlayer5 ))
				{
				TopPlayer6 = SPlayer[a];
				TopFrags6 = SFrags[a];
				TopGames6 = SGames[a];
				}
			}
		}
	// find #7
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if (( SFrags[a] >= TopFrags7 ) && ( SPlayer[a] != TopPlayer1 ) && ( SPlayer[a] != TopPlayer2 ) && ( SPlayer[a] != TopPlayer3 ) && ( SPlayer[a] != TopPlayer4 ) && ( SPlayer[a] != TopPlayer5 ) && ( SPlayer[a] != TopPlayer6 ))
				{
				TopPlayer7 = SPlayer[a];
				TopFrags7 = SFrags[a];
				TopGames7 = SGames[a];
				}
			}
		}
	// find #8
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if (( SFrags[a] >= TopFrags8 ) && ( SPlayer[a] != TopPlayer1 ) && ( SPlayer[a] != TopPlayer2 ) && ( SPlayer[a] != TopPlayer3 ) && ( SPlayer[a] != TopPlayer4 ) && ( SPlayer[a] != TopPlayer5 ) && ( SPlayer[a] != TopPlayer6 ) && ( SPlayer[a] != TopPlayer7 ))
				{
				TopPlayer8 = SPlayer[a];
				TopFrags8 = SFrags[a];
				TopGames8 = SGames[a];
				}
			}
		}
	// find #9
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if (( SFrags[a] >= TopFrags9 ) && ( SPlayer[a] != TopPlayer1 ) && ( SPlayer[a] != TopPlayer2 ) && ( SPlayer[a] != TopPlayer3 ) && ( SPlayer[a] != TopPlayer4 ) && ( SPlayer[a] != TopPlayer5 ) && ( SPlayer[a] != TopPlayer6 ) && ( SPlayer[a] != TopPlayer7 ) && ( SPlayer[a] != TopPlayer8 ))
				{
				TopPlayer9 = SPlayer[a];
				TopFrags9 = SFrags[a];
				TopGames9 = SGames[a];
				}
			}
		}
	// find #10
	for ( a=0; a<10000; a++ )
		{
		if ( SPlayer[a] != "" )
			{
			if (( SFrags[a] >= TopFrags10 ) && ( SPlayer[a] != TopPlayer1 ) && ( SPlayer[a] != TopPlayer2 ) && ( SPlayer[a] != TopPlayer3 ) && ( SPlayer[a] != TopPlayer4 ) && ( SPlayer[a] != TopPlayer5 ) && ( SPlayer[a] != TopPlayer6 ) && ( SPlayer[a] != TopPlayer7 ) && ( SPlayer[a] != TopPlayer8 ) && ( SPlayer[a] != TopPlayer9 ))
				{
				TopPlayer10 = SPlayer[a];
				TopFrags10 = SFrags[a];
				TopGames10 = SGames[a];
				}
			}
		}
	bRunOnce = True;
	log("Survival Statistics - The stats have been calculated and transfered to the database.");
	}

}
function bool HandleEndGame()
{
	GatherStats();
	SendStatsToDB();
	SaveConfig();
	bRunOnce = True;

}

/*
function Mutate (string MutateString, PlayerPawn Sender)
{
local Pawn p;

if ((Left(MutateString,11) ~= "Purge Stats")&& Sender.bAdmin)
	{
	if ( bPurgeInactivePlayers )
		{
		bPurgeInactivePlayers = False;
		Sender.ClientMessage("The statistics will no longer purge players!");
       		}
	else
		{
		bPurgeInactivePlayers =True;
		Sender.ClientMessage("players who are inactive for "@InactiveDays$" days will now be purged");
       		}
	SaveConfig();
	}

}
*/

defaultproperties
{
	bHidden=True
}