class SV_SurvivalHUD extends SV_HUD;

var color ElementColor, TextColor, BarColor;
var PlayerPawn Player;
var FontInfo MyFonts;
var bool bShowTree;

//HUD location vars:
var string Xloc,Xloc2;
var float Yloc, Xlocation, Ylocation;

//Next level progress:
var float Progress;

//Vars to show on RPG HUD:
var int MyLevel,MyStats,Skill1,Skill2,Skill3,Skill4,Skill5,Skill6;
var float MyProgress;

simulated function PostRender(Canvas C)
{
	
	local int X, Y;
	local float XL, YL;
	local int i;
	
	Super(ChallengeTeamHUD).PostRender(C);
	
	if (bHideHud
		|| ((C.ClipX <= 400) && ((PlayerPawn(Owner).bShowScores) || bForceScores))) 
        {
		return;
	}
	
	if (TournamentConsole(PlayerPawn(Owner).Player.Console).bShowSpeech)
		return;
	
	C.bNoSmooth = False;
	DrawMonsterName(C);
	C.bNoSmooth = True;
	
	DrawStatTree(C);
}

simulated function DrawMonsterName(Canvas C)
{
	
	local float Dist, XN, YN, YNOffset;
	local ScriptedPawn P;
	local int XPos, YPos;
	local Vector X,Y,Z, Dir;
	local PlayerPawn PP;
	local TournamentGameReplicationInfo TGRI;

	TGRI = TournamentGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);

//Grab replicated vars for the RPG Plugin:
	Xloc = SV_ReplicationInfo(TGRI).Xpos;
	Yloc = SV_ReplicationInfo(TGRI).Ypos;
	Xloc2 = SV_ReplicationInfo(TGRI).Xpos2;
	
	Progress = SV_ReplicationInfo(TGRI).Progress;

	GetAxes(Owner.Rotation, X, Y, Z);
	C.Font = Font'WhiteFont';
	
	C.Style = ERenderStyle.STY_Normal;

	if ( SV_ReplicationInfo(TGRI).bShowMonsterHealth )
		{
		foreach VisibleCollidingActors(class'ScriptedPawn', P, 1500, Owner.Location, true)//2000
			{
			Dir = P.Location - Owner.Location;
			Dist = VSize(Dir);
			Dir = Dir / Dist;
			if ((Dir Dot X) > 0.7)
				{
				XPos = 0.5 * C.ClipX * (1 + 1.4 * (Dir Dot Y));
				YPos = 0.5 * C.ClipY * (1 - 1.4 * (Dir Dot Z));
				C.SetPos(Xpos , YPos );
				C.DrawText(P.class.Name$"("$P.Health$")", true);
				}
			}
		}
	ShowRaderBase(C);
	ShowRadar(C);
}

simulated function DrawStatTree(canvas Canvas)
{
local float XL,YL, YLL;

SetPositions(Canvas);

//Draw HUD Element:
Canvas.Style = ERenderStyle.STY_Translucent;
Canvas.SetPos(Xlocation, Ylocation);
Canvas.DrawColor = ElementColor;
Canvas.DrawIcon(Texture'Survival2.RPGelement', 1);

//Draw status bar to element:
Canvas.Style = ERenderStyle.STY_Translucent;
Canvas.SetPos(Xlocation + 119, Ylocation + 33);
Canvas.DrawColor = BarColor;
Canvas.DrawTile(Texture'Survival2.RPGstatusbar', 128 * Progress, 8, 0, 0, 128.0, 8.0);

//Draw Level and stat count:
Canvas.Style = ERenderStyle.STY_Normal;
Canvas.DrawColor = TextColor;
Canvas.Font = Font'Botpack.BigFont';
Canvas.TextSize("TEST", XL, YL);
Canvas.SetPos(Xlocation + 3, Ylocation + 3);
Canvas.DrawText("LEVEL: 9");
Canvas.SetPos(Xlocation + 100, Ylocation + 3);
Canvas.DrawText("STAT POINTS: 1");
Canvas.SetPos(Xlocation + 3, Ylocation + 10 + YL);
Canvas.DrawText("NEXT LEVEL:");

SetTreePosition(Canvas);

//Draw Stat tree:
if ( bShowTree )
	{
	//DamageAmp:
	Canvas.Style = ERenderStyle.STY_Translucent;
	Canvas.SetPos(Xlocation, Ylocation);
	Canvas.DrawColor = ElementColor;
	Canvas.DrawIcon(Texture'Survival2.StatTreeElement', 1);
	Canvas.SetPos(Xlocation + 13, Ylocation + 8);
	Canvas.DrawColor = TextColor;
	Canvas.DrawTile(Texture'Survival2.Icon_DamageAmp', 48, 48, 0, 0, 48.0, 48.0);
	Canvas.Style = ERenderStyle.STY_Normal;
	Canvas.Font = Font'Botpack.BigFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 164, Ylocation + 41);
	Canvas.DrawText("LEVEL: 6");
	Canvas.Font = Font'Botpack.SmallFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 64, Ylocation + 6);
	Canvas.DrawText("Add Damage To Your Attack.");
	Canvas.SetPos(Xlocation + 64, Ylocation + 6 + YL);
	Canvas.DrawText("Current Attack Rating: 106%");
	Ylocation +=64;

	//ReduceDamage:
	Canvas.Style = ERenderStyle.STY_Translucent;
	Canvas.SetPos(Xlocation, Ylocation);
	Canvas.DrawColor = ElementColor;
	Canvas.DrawIcon(Texture'Survival2.StatTreeElement', 1);
	Canvas.SetPos(Xlocation + 13, Ylocation + 8);
	Canvas.DrawColor = TextColor;
	Canvas.DrawTile(Texture'Survival2.Icon_ReduceDamage', 48, 48, 0, 0, 48.0, 48.0);
	Canvas.Style = ERenderStyle.STY_Normal;
	Canvas.Font = Font'Botpack.BigFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 164, Ylocation + 41);
	Canvas.DrawText("LEVEL: 4");
	Canvas.Font = Font'Botpack.SmallFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 64, Ylocation + 6);
	Canvas.DrawText("Reduce Damage Done To You.");
	Canvas.SetPos(Xlocation + 64, Ylocation + 6 + YL);
	Canvas.DrawText("Current Damage Taken: 96%");
	Ylocation +=64;

	//AmmoRegain:
	Canvas.Style = ERenderStyle.STY_Translucent;
	Canvas.SetPos(Xlocation, Ylocation);
	Canvas.DrawColor = ElementColor;
	Canvas.DrawIcon(Texture'Survival2.StatTreeElement', 1);
	Canvas.SetPos(Xlocation + 13, Ylocation + 8);
	Canvas.DrawColor = TextColor;
	Canvas.DrawTile(Texture'Survival2.Icon_AmmoRegain', 48, 48, 0, 0, 48.0, 48.0);
	Canvas.Style = ERenderStyle.STY_Normal;
	Canvas.Font = Font'Botpack.BigFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 164, Ylocation + 41);
	Canvas.DrawText("LEVEL: 4");
	Canvas.Font = Font'Botpack.SmallFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 64, Ylocation + 6);
	Canvas.DrawText("Regain Ammo.");
	Canvas.SetPos(Xlocation + 64, Ylocation + 6 + YL);
	Canvas.DrawText("Current Regain Rate: 4%");
	Ylocation +=64;

	//HealthRegain:
	Canvas.Style = ERenderStyle.STY_Translucent;
	Canvas.SetPos(Xlocation, Ylocation);
	Canvas.DrawColor = ElementColor;
	Canvas.DrawIcon(Texture'Survival2.StatTreeElement', 1);
	Canvas.SetPos(Xlocation + 13, Ylocation + 8);
	Canvas.DrawColor = TextColor;
	Canvas.DrawTile(Texture'Survival2.Icon_HealthRegain', 48, 48, 0, 0, 48.0, 48.0);
	Canvas.Style = ERenderStyle.STY_Normal;
	Canvas.Font = Font'Botpack.BigFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 164, Ylocation + 41);
	Canvas.DrawText("LEVEL: 8");
	Canvas.Font = Font'Botpack.SmallFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 64, Ylocation + 6);
	Canvas.DrawText("Regain Health.");
	Canvas.SetPos(Xlocation + 64, Ylocation + 6 + YL);
	Canvas.DrawText("Current Regain Rate: 8%");
	Ylocation +=64;

	//ArmorRegain:
	Canvas.Style = ERenderStyle.STY_Translucent;
	Canvas.SetPos(Xlocation, Ylocation);
	Canvas.DrawColor = ElementColor;
	Canvas.DrawIcon(Texture'Survival2.StatTreeElement', 1);
	Canvas.SetPos(Xlocation + 13, Ylocation + 8);
	Canvas.DrawColor = TextColor;
	Canvas.DrawTile(Texture'Survival2.Icon_ArmorRegain', 48, 48, 0, 0, 48.0, 48.0);
	Canvas.Style = ERenderStyle.STY_Normal;
	Canvas.Font = Font'Botpack.BigFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 164, Ylocation + 41);
	Canvas.DrawText("LEVEL: 8");
	Canvas.Font = Font'Botpack.SmallFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 64, Ylocation + 6);
	Canvas.DrawText("Regain Armor.");
	Canvas.SetPos(Xlocation + 64, Ylocation + 6 + YL);
	Canvas.DrawText("Current Regain Rate: 8%");
	Canvas.SetPos(Xlocation + 64, Ylocation + 6 + YL*2);
	Canvas.DrawText("Current Max Regain: 150");
	Ylocation +=64;

	//SpeedAmp:
	Canvas.Style = ERenderStyle.STY_Translucent;
	Canvas.SetPos(Xlocation, Ylocation);
	Canvas.DrawColor = ElementColor;
	Canvas.DrawIcon(Texture'Survival2.StatTreeElement', 1);
	Canvas.SetPos(Xlocation + 13, Ylocation + 8);
	Canvas.DrawColor = TextColor;
	Canvas.DrawTile(Texture'Survival2.Icon_SpeedAmp', 48, 48, 0, 0, 48.0, 48.0);
	Canvas.Style = ERenderStyle.STY_Normal;
	Canvas.Font = Font'Botpack.BigFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 164, Ylocation + 41);
	Canvas.DrawText("LEVEL: 4");
	Canvas.Font = Font'Botpack.SmallFont';
	Canvas.TextSize("TEST", XL, YL);
	Canvas.SetPos(Xlocation + 64, Ylocation + 6);
	Canvas.DrawText("Elemental Control.");
	Canvas.SetPos(Xlocation + 64, Ylocation + 6 + YL);
	Canvas.DrawText("Current Elemental Control: 104%");
	}
}

function SetPositions(Canvas Canvas)
{

//set X position:
if ( Xloc == "left" || Xloc == "Left" )
	{
	Xlocation = 0;
	}
else if ( Xloc == "right" || Xloc == "Right" )
	{
	Xlocation = Canvas.ClipX - 256;
	}
else
	{
	Xlocation = Canvas.ClipX * 0.5 - 128;
	}

//set Y position
if ( Yloc < 0.029 )
	{
	Yloc = 0.029;
	}
else if ( Yloc >= 1 )
	{
	Yloc = 1;
	}
Ylocation = Canvas.ClipY * Yloc - 24;

}

function SetTreePosition(Canvas Canvas)
{
if ( Xloc2 == "left" || Xloc2 == "Left" )
	{
	Xlocation = 0;
	}
else if ( Xloc2 == "center" || Xloc2 == "Center" )
	{
	Xlocation = Canvas.ClipX * 0.5 - 128;
	}
else
	{
	Xlocation = Canvas.ClipX - 256;
	}
Ylocation = Canvas.ClipY * 0.5 - 192;
}

defaultproperties
{
ElementColor=(R=55,G=55,B=55)
TextColor=(R=255,G=255,B=255)
BarColor=(R=0,G=255,B=0)
bShowTree=True
}