

class SV_SurvivalMonsterController extends Inventory;

var ScriptedPawn MonsterOwner;

event Destroyed() 
{
	
	super.Destroyed();
}

function Activate()
{

	MonsterOwner = ScriptedPawn(Owner);
	if (OwnerInitialize())
		SetTimer(0.1, true);
	else
		Destroy();
}

function bool OwnerInitialize()
{
	
	if (Owner.IsA('ScriptedPawn')) 
        {
		if (MonsterOwner != None)
			MonsterOwner = ScriptedPawn(Owner);
		MonsterOwner.SightRadius *= 5;
		return true;
	}
	return false;
}

function Timer()
{
	
	if (Level.Game.bGameEnded || MonsterOwner == None || Pawn(Owner).bIsPlayer)
		Destroy();
	
	TweakMonster();
} 


function TweakMonster() 
{
	
	local Pawn P, E;
	local float rad, vec;
	local int i;
	local SV_ReplicationInfo ACGRI;
	
	ACGRI = SV_ReplicationInfo(Level.Game.GameReplicationInfo);
	if (Level.Game.bGameEnded || ACGRI.PlayerTotal <= 0
		|| MonsterOwner == None || MonsterOwner.IsInState('Dying'))
		return;
	
	if (MonsterOwner.Enemy != None
		&& (MonsterOwner.Enemy.IsA('PlayerPawn') || MonsterOwner.Enemy.IsA('Bot'))) 
                {
		
		if (MonsterOwner.ActorReachable(MonsterOwner.Enemy))
			MonsterOwner.MoveTarget = MonsterOwner.Enemy;
		else
			MonsterOwner.MoveTarget = MonsterOwner.FindPathToWard(MonsterOwner.Enemy);
	}
	
	if (MonsterOwner.Enemy == None || MonsterOwner.Enemy.IsA('ScriptedPawn')) 
        {
		E = None;
		rad = 999999;
		for (P = Level.PawnList; P != None; P = P.NextPawn) {
			if (!P.bHidden && (P.IsA('PlayerPawn') || P.IsA('Bot'))) 
                        {
				vec = VSize(P.Location - MonsterOwner.Location);
				if (vec < rad) 
                                {
					E = P;
					rad = vec;
				}
			}
		}
		if (E != None) 
                {
			MonsterOwner.Hated = E;
			MonsterOwner.Enemy = E;
			MonsterOwner.SetEnemy(E);
			MonsterOwner.GotoState('Attacking');
		} 
                else 
                {
			MonsterOwner.Hated = None;
			MonsterOwner.Enemy = None;
			MonsterOwner.bHunting = false;
			MonsterOwner.GotoState('Roaming');
		}
	}
}

defaultproperties
{
}
