

#exec Audio Import File="Sounds\NextWaveIn.wav" Name="NextWaveIn"
#exec Audio Import File="Sounds\WaveSurviver.wav" Name="WaveSurviver"

class SV_WaveStartingMessage extends CriticalEventPlus;

var localized String StartMsg1;
var localized String StartMsg2;
var Sound NextWaveIn;
var Sound WaveSurviver;

static function string GetString(
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
) 
{
	return Default.StartMsg1@Switch@Default.StartMsg2;
}

static simulated function ClientReceive( 
	PlayerPawn P,
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
) 
{
	Super.ClientReceive(P, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
	
	if (OptionalObject != None) 
        {
		P.ClientPlaySound(Default.WaveSurviver, , true);
	} 
        else 
        {
		P.ClientPlaySound(Default.NextWaveIn, , true);
	}
}

defaultproperties
{
    StartMsg1="Wave Round"
    StartMsg2="Get Ready."
    NextWaveIn=Sound'NextWaveIn'
    WaveSurviver=Sound'WaveSurviver'
    bBeep=False
}
